function Snapshot= SimSonic3DReadSnp3D(FileName)


% SIMSONIC3DREADSNP3D reads .snp3D snapshot file
%
%   SNAPSHOT = SIMSONIC3DREADSNP3D(FILENAME) reads FileName into a
%   structure SNAPSHOT
%
%   SimSonic3D toolbox
%   Author: Emmanuel Bossy
%   Date: 2012/11/19


fid=fopen(FileName,'rb');

Nx=fread(fid,1,'int');
Ny=fread(fid,1,'int');
Nz=fread(fid,1,'int');
t=fread(fid,1,'double');
H=fread(fid,1,'double');
DeltaT=fread(fid,1,'double');
Donnees=fread(fid,'float');
Donnees=reshape(Donnees,Nz,Ny,Nx);
Donnees=permute(Donnees,[3 2 1]);
Max=max(abs(Donnees(:)));

fclose(fid);


Snapshot=struct(...
    'N1',Nx,...
    'N2',Ny,...
    'N3',Nz,...
    'Time_us',t,...
    'Grid_step_mm',H,...
    'Time_step_us',DeltaT,...
    'Data',Donnees,...
    'Max',Max);
