/* Copyright (C) 2003-2012 BOSSY Emmanuel.

This file is part of the SimSonic suite.

SimSonic is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SimSonic is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SimSonic.  If not, see <http://www.gnu.org/licenses/>. */

void CalculPMLAreteContraintes(PREC_GRILLE *Vi_I,PREC_GRILLE *Vi_J,PREC_GRILLE *Vi_K,
                               PREC_GRILLE *Vj_I,PREC_GRILLE *Vj_J,PREC_GRILLE *Vj_K,
                               PREC_GRILLE *Vk_I,PREC_GRILLE *Vk_J,PREC_GRILLE *Vk_K,
                               PREC_GRILLE *Tii_I,PREC_GRILLE *Tii_J,PREC_GRILLE *Tii_K,
                               PREC_GRILLE *Tjj_I,PREC_GRILLE *Tjj_J,PREC_GRILLE *Tjj_K,
                               PREC_GRILLE *Tkk_I,PREC_GRILLE *Tkk_J,PREC_GRILLE *Tkk_K,
                               PREC_GRILLE *Tij_I,PREC_GRILLE *Tij_J,
                               PREC_GRILLE *Tjk_J,PREC_GRILLE *Tjk_K,
                               PREC_GRILLE *Tki_K,PREC_GRILLE *Tki_I,
                               int K,
                               const char *TypeArete)
{

    int i,j,k;
    double Cjkjk,Ckiki,Cijij;/* (4: jk, 5: ki, 6:ij)*/
    double SignI, SignJ;

    if (!strcmp(TypeArete,"XpYm")||!strcmp(TypeArete,"XpYp")||
            !strcmp(TypeArete,"YpZm")||!strcmp(TypeArete,"YpZp")||
            !strcmp(TypeArete,"ZpXm")||!strcmp(TypeArete,"ZpXp"))
        SignI = +1.0;
    else
        SignI = -1.0;

    if (!strcmp(TypeArete,"XmYp")||!strcmp(TypeArete,"XpYp")||
            !strcmp(TypeArete,"YmZp")||!strcmp(TypeArete,"YpZp")||
            !strcmp(TypeArete,"ZmXp")||!strcmp(TypeArete,"ZpXp"))
        SignJ = +1.0;
    else
        SignJ = -1.0;

    /*   Bloc Arete PML*/



#pragma omp parallel for private(j,k) schedule(guided)
    for (i=1; i<W; i++)
    {
        for (j=1; j<(W); j++)
        {
            for (k=0; k<K; k++)
            {

                Tii_I[(i)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                       (1-DeltaT*AttenuationPML[2*i])*Tii_I[(i)*(W+1)*(K)+(j)*(K)+(k)]													+
                                                       DeltaTsurH*TableCii[Carte_Tampon[k]]*(
                                                               SignI*(	(Vi_I[(i)*(W+1)*(K)+(j)*(K)+(k)]	+ Vi_J[(i)*(W+1)*(K)+(j)*(K)+(k)]		+ Vi_K[(i)*(W+1)*(K)+(j)*(K)+(k)]	)
                                                                       -	(Vi_I[(i-1)*(W+1)*(K)+(j)*(K)+(k)]+ Vi_J[(i-1)*(W+1)*(K)+(j)*(K)+(k)]	+ Vi_K[(i-1)*(W+1)*(K)+(j)*(K)+(k)])	)	)	);

                Tii_J[(i)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                                                       (1-DeltaT*AttenuationPML[2*j])*Tii_J[(i)*(W+1)*(K)+(j)*(K)+(k)]													+
                                                       DeltaTsurH*TableCij[Carte_Tampon[k]]*(
                                                               SignJ*(	(Vj_I[(i)*(W)*(K)+(j)*(K)+(k)]	+ Vj_J[(i)*(W)*(K)+(j)*(K)+(k)]		+ Vj_K[(i)*(W)*(K)+(j)*(K)+(k)])
                                                                       -	(Vj_I[(i)*(W)*(K)+(j-1)*(K)+(k)]+ Vj_J[(i)*(W)*(K)+(j-1)*(K)+(k)]	+ Vj_K[(i)*(W)*(K)+(j-1)*(K)+(k)])	)	)	);

                Tii_K[(i)*(W+1)*(K)+(j)*(K)+(k)] += DeltaTsurH*(
                                                        TableCki[Carte_Tampon[k]]*(
                                                                (Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]+ Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	+	Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	)
                                                                -	(Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]	+ Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]		+	Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]	)	)	);


                Tjj_I[(i)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                       (1-DeltaT*AttenuationPML[2*i])*Tjj_I[(i)*(W+1)*(K)+(j)*(K)+(k)]													+
                                                       DeltaTsurH*TableCij[Carte_Tampon[k]]*(
                                                               SignI*(	(Vi_I[(i)*(W+1)*(K)+(j)*(K)+(k)]	+ Vi_J[(i)*(W+1)*(K)+(j)*(K)+(k)]		+ Vi_K[(i)*(W+1)*(K)+(j)*(K)+(k)]	)
                                                                       -	(Vi_I[(i-1)*(W+1)*(K)+(j)*(K)+(k)]+ Vi_J[(i-1)*(W+1)*(K)+(j)*(K)+(k)]	+ Vi_K[(i-1)*(W+1)*(K)+(j)*(K)+(k)])	)	)	);

                Tjj_J[(i)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                                                       (1-DeltaT*AttenuationPML[2*j])*Tjj_J[(i)*(W+1)*(K)+(j)*(K)+(k)]													+
                                                       DeltaTsurH*TableCjj[Carte_Tampon[k]]*(
                                                               SignJ*(	(Vj_I[(i)*(W)*(K)+(j)*(K)+(k)]	+ Vj_J[(i)*(W)*(K)+(j)*(K)+(k)]		+ Vj_K[(i)*(W)*(K)+(j)*(K)+(k)])
                                                                       -	(Vj_I[(i)*(W)*(K)+(j-1)*(K)+(k)]+ Vj_J[(i)*(W)*(K)+(j-1)*(K)+(k)]	+ Vj_K[(i)*(W)*(K)+(j-1)*(K)+(k)])	)	)	);

                Tjj_K[(i)*(W+1)*(K)+(j)*(K)+(k)] += DeltaTsurH*(
                                                        TableCjk[Carte_Tampon[k]]*(
                                                                (Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]+ Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	+	Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	)
                                                                -	(Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]	+ Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]		+	Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]	)	)	);



                Tkk_I[(i)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                       (1-DeltaT*AttenuationPML[2*i])*Tkk_I[(i)*(W+1)*(K)+(j)*(K)+(k)]													+
                                                       DeltaTsurH*TableCki[Carte_Tampon[k]]*(
                                                               SignI*(	(Vi_I[(i)*(W+1)*(K)+(j)*(K)+(k)]	+ Vi_J[(i)*(W+1)*(K)+(j)*(K)+(k)]		+ Vi_K[(i)*(W+1)*(K)+(j)*(K)+(k)]	)
                                                                       -	(Vi_I[(i-1)*(W+1)*(K)+(j)*(K)+(k)]+ Vi_J[(i-1)*(W+1)*(K)+(j)*(K)+(k)]	+ Vi_K[(i-1)*(W+1)*(K)+(j)*(K)+(k)])	)	)	);

                Tkk_J[(i)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                                                       (1-DeltaT*AttenuationPML[2*j])*Tkk_J[(i)*(W+1)*(K)+(j)*(K)+(k)]													+
                                                       DeltaTsurH*TableCjk[Carte_Tampon[k]]*(
                                                               SignJ*(	(Vj_I[(i)*(W)*(K)+(j)*(K)+(k)]	+ Vj_J[(i)*(W)*(K)+(j)*(K)+(k)]		+ Vj_K[(i)*(W)*(K)+(j)*(K)+(k)])
                                                                       -	(Vj_I[(i)*(W)*(K)+(j-1)*(K)+(k)]+ Vj_J[(i)*(W)*(K)+(j-1)*(K)+(k)]	+ Vj_K[(i)*(W)*(K)+(j-1)*(K)+(k)])	)	)	);

                Tkk_K[(i)*(W+1)*(K)+(j)*(K)+(k)] += DeltaTsurH*(
                                                        TableCkk[Carte_Tampon[k]]*(
                                                                (Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]+ Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	+	Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	)
                                                                -	(Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]	+ Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]		+	Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]	)	)	);

                /*rq: si il y a un bug dans un des 3 Tii, comme c'est fait par copier/coller, ne pas oublier de tout corriger...*/
            }
        }
    }



#pragma omp parallel for private(j,k,Cijij) schedule(guided)
    for (i=0; i<W; i++)
    {
        for (j=0; j<W; j++)
        {
            for (k=0; k<K; k++)
            {


                Cijij=TableCijij[Carte_Tampon[k]];


                Tij_I[(i)*(W)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*	(
                                                     (1-DeltaT*AttenuationPML[1+2*i])*Tij_I[(i)*(W)*(K)+(j)*(K)+(k)]											+
                                                     DeltaTsurH*Cijij*(
                                                             SignI*(	(Vj_I[(i+1)*(W)*(K)+(j)*(K)+(k)]	+Vj_J[(i+1)*(W)*(K)+(j)*(K)+(k)]	+Vj_K[(i+1)*(W)*(K)+(j)*(K)+(k)])
                                                                     -	(Vj_I[(i)*(W)*(K)+(j)*(K)+(k)]		+Vj_J[(i)*(W)*(K)+(j)*(K)+(k)]		+Vj_K[(i)*(W)*(K)+(j)*(K)+(k)])	)	)	);

                Tij_J[(i)*(W)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*j])*	(
                                                     (1-DeltaT*AttenuationPML[1+2*j])*Tij_J[(i)*(W)*(K)+(j)*(K)+(k)]											+
                                                     DeltaTsurH*Cijij*(
                                                             SignJ*(	(Vi_I[(i)*(W+1)*(K)+(j+1)*(K)+(k)]	+Vi_J[(i)*(W+1)*(K)+(j+1)*(K)+(k)]	+Vi_K[(i)*(W+1)*(K)+(j+1)*(K)+(k)])
                                                                     -	(Vi_I[(i)*(W+1)*(K)+(j)*(K)+(k)]		+Vi_J[(i)*(W+1)*(K)+(j)*(K)+(k)]		+Vi_K[(i)*(W+1)*(K)+(j)*(K)+(k)])	)	)	);
            }
        }
    }

#pragma omp parallel for private(j,k,Cjkjk) schedule(guided)
    for (i=0; i<(W+1); i++)
    {
        for (j=0; j<W; j++)
        {
            for (k=1; k<K; k++)
            {

                if (TableCjkjk[Carte_Tampon[(k-1)]]*
                        TableCjkjk[Carte_Tampon[(k)]])
                {

                    Cjkjk=2./(1./TableCjkjk[Carte_Tampon[(k-1)]]+
                              1./TableCjkjk[Carte_Tampon[(k)]]);
                }
                else
                {
                    Cjkjk=0.0;
                }

                Tjk_J[(i)*(W)*(K+1)+(j)*(K+1)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*j])*	(
                        (1-DeltaT*AttenuationPML[1+2*j])*Tjk_J[(i)*(W)*(K+1)+(j)*(K+1)+(k)]											+
                        DeltaTsurH*Cjkjk*(
                            SignJ*(	(Vk_I[(i)*(W+1)*(K+1)+(j+1)*(K+1)+(k)]+	Vk_J[(i)*(W+1)*(K+1)+(j+1)*(K+1)+(k)]+Vk_K[(i)*(W+1)*(K+1)+(j+1)*(K+1)+(k)])
                                    -	(Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]	+	Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]	+	Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)])	)	)	);

                Tjk_K[(i)*(W)*(K+1)+(j)*(K+1)+(k)] += DeltaTsurH*Cjkjk*(
                        (	(Vj_I[(i)*(W)*(K)+(j)*(K)+(k)]		+Vj_J[(i)*(W)*(K)+(j)*(K)+(k)]		+Vj_K[(i)*(W)*(K)+(j)*(K)+(k)]	)
                            -	(Vj_I[(i)*(W)*(K)+(j)*(K)+(k-1)]	+Vj_J[(i)*(W)*(K)+(j)*(K)+(k-1)]	+Vj_K[(i)*(W)*(K)+(j)*(K)+(k-1)])	)	);
            }
        }
    }


#pragma omp parallel for private(j,k,Ckiki) schedule(guided)
    for (i=0; i<W; i++)
    {
        for (j=0; j<(W+1); j++)
        {
            for (k=1; k<K; k++)
            {

                if (TableCkiki[Carte_Tampon[(k-1)]]*
                        TableCkiki[Carte_Tampon[(k)]])
                {

                    Ckiki=2./(1./TableCkiki[Carte_Tampon[(k-1)]]+
                              1./TableCkiki[Carte_Tampon[(k)]]);
                }
                else
                {
                    Ckiki=0.0;
                }


                Tki_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*	(
                        (1-DeltaT*AttenuationPML[1+2*i])*Tki_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]													+
                        DeltaTsurH*Ckiki*(
                            SignI*(	(Vk_I[(i+1)*(W+1)*(K+1)+(j)*(K+1)+(k)]	+Vk_J[(i+1)*(W+1)*(K+1)+(j)*(K+1)+(k)]	+Vk_K[(i+1)*(W+1)*(K+1)+(j)*(K+1)+(k)])
                                    -	(Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]		+Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)]		+Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)])	)	)	);

                Tki_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(k)] += DeltaTsurH*Ckiki*(
                        (Vi_I[(i)*(W+1)*(K)+(j)*(K)+(k)]	+Vi_J[(i)*(W+1)*(K)+(j)*(K)+(k)]	+Vi_K[(i)*(W+1)*(K)+(j)*(K)+(k)])
                        -	(Vi_I[(i)*(W+1)*(K)+(j)*(K)+(k-1)]+Vi_J[(i)*(W+1)*(K)+(j)*(K)+(k-1)]+Vi_K[(i)*(W+1)*(K)+(j)*(K)+(k-1)])	);

            }
        }
    }
    /******************************  Face Jm sur PML Face I*********************/

#pragma omp parallel for private(k) schedule(guided)
    for (i=1; i<W; i++)
    {
        for (k=0; k<K; k++)
        {

            Tii_I[(i)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                   (1-DeltaT*AttenuationPML[2*i])*Tii_I[(i)*(W+1)*(K)+(0)*(K)+(k)]													+
                                                   DeltaTsurH*TableCii[Carte_Tampon[k]]*(
                                                           SignI*(	(Vi_I[(i)*(W+1)*(K)+(0)*(K)+(k)]	+ Vi_J[(i)*(W+1)*(K)+(0)*(K)+(k)]		+ Vi_K[(i)*(W+1)*(K)+(0)*(K)+(k)]	)
                                                                   -	(Vi_I[(i-1)*(W+1)*(K)+(0)*(K)+(k)]+ Vi_J[(i-1)*(W+1)*(K)+(0)*(K)+(k)]	+ Vi_K[(i-1)*(W+1)*(K)+(0)*(K)+(k)])	)	)	);

            Tii_J[(i)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                   (1-DeltaT*AttenuationPML[2*0])*Tii_J[(i)*(W+1)*(K)+(0)*(K)+(k)]													+
                                                   DeltaTsurH*TableCij[Carte_Tampon[k]]*(
                                                           SignJ*(	(Vj_I[(i)*(W)*(K)+(0)*(K)+(k)]	+ Vj_J[(i)*(W)*(K)+(0)*(K)+(k)]		+ Vj_K[(i)*(W)*(K)+(0)*(K)+(k)]	)
                                                                   -	(Vj_BufferAreteFaceI[i*(K)+k])																																		)	)	);


            Tii_K[(i)*(W+1)*(K)+(0)*(K)+(k)] += DeltaTsurH*(
                                                    TableCki[Carte_Tampon[k]]*(
                                                            (Vk_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]+ Vk_J[(i)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	+	Vk_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	)
                                                            -	(Vk_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)]	+ Vk_J[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)]		+	Vk_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)]	)	)	);


            Tjj_I[(i)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                   (1-DeltaT*AttenuationPML[2*i])*Tjj_I[(i)*(W+1)*(K)+(0)*(K)+(k)]													+
                                                   DeltaTsurH*TableCij[Carte_Tampon[k]]*(
                                                           SignI*(	(Vi_I[(i)*(W+1)*(K)+(0)*(K)+(k)]	+ Vi_J[(i)*(W+1)*(K)+(0)*(K)+(k)]		+ Vi_K[(i)*(W+1)*(K)+(0)*(K)+(k)]	)
                                                                   -	(Vi_I[(i-1)*(W+1)*(K)+(0)*(K)+(k)]+ Vi_J[(i-1)*(W+1)*(K)+(0)*(K)+(k)]	+ Vi_K[(i-1)*(W+1)*(K)+(0)*(K)+(k)])	)	)	);

            Tjj_J[(i)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                   (1-DeltaT*AttenuationPML[2*0])*Tjj_J[(i)*(W+1)*(K)+(0)*(K)+(k)]													+
                                                   DeltaTsurH*TableCjj[Carte_Tampon[k]]*(
                                                           SignJ*(	(Vj_I[(i)*(W)*(K)+(0)*(K)+(k)]	+ Vj_J[(i)*(W)*(K)+(0)*(K)+(k)]		+ Vj_K[(i)*(W)*(K)+(0)*(K)+(k)]	)
                                                                   -	(Vj_BufferAreteFaceI[i*(K)+k]																																			)	)	)	);


            Tjj_K[(i)*(W+1)*(K)+(0)*(K)+(k)] += DeltaTsurH*(
                                                    TableCjk[Carte_Tampon[k]]*(
                                                            (Vk_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]+ Vk_J[(i)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	+	Vk_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	)
                                                            -	(Vk_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)]	+ Vk_J[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)]		+	Vk_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)]	)	)	);

            Tkk_I[(i)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                   (1-DeltaT*AttenuationPML[2*i])*Tkk_I[(i)*(W+1)*(K)+(0)*(K)+(k)]													+
                                                   DeltaTsurH*TableCki[Carte_Tampon[k]]*(
                                                           SignI*(	(Vi_I[(i)*(W+1)*(K)+(0)*(K)+(k)]	+ Vi_J[(i)*(W+1)*(K)+(0)*(K)+(k)]		+ Vi_K[(i)*(W+1)*(K)+(0)*(K)+(k)]	)
                                                                   -	(Vi_I[(i-1)*(W+1)*(K)+(0)*(K)+(k)]+ Vi_J[(i-1)*(W+1)*(K)+(0)*(K)+(k)]	+ Vi_K[(i-1)*(W+1)*(K)+(0)*(K)+(k)])	)	)	);

            Tkk_J[(i)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                   (1-DeltaT*AttenuationPML[2*0])*Tkk_J[(i)*(W+1)*(K)+(0)*(K)+(k)]													+
                                                   DeltaTsurH*TableCjk[Carte_Tampon[k]]*(
                                                           SignJ*(	(Vj_I[(i)*(W)*(K)+(0)*(K)+(k)]	+ Vj_J[(i)*(W)*(K)+(0)*(K)+(k)]		+ Vj_K[(i)*(W)*(K)+(0)*(K)+(k)]	)
                                                                   -	(Vj_BufferAreteFaceI[i*(K)+k]																																			)	)	)	);


            Tkk_K[(i)*(W+1)*(K)+(0)*(K)+(k)] += DeltaTsurH*(
                                                    TableCkk[Carte_Tampon[k]]*(
                                                            (Vk_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]+ Vk_J[(i)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	+	Vk_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	)
                                                            -	(Vk_I[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)]	+ Vk_J[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)]		+	Vk_K[(i)*(W+1)*(K+1)+(0)*(K+1)+(k)]	)	)	);

        }
    }
    /*rq: si il y a un bug dans un des 3 Tii, comme c'est fait par copier/coller, ne pas oublier de tout corriger...*/
    /*Tki est deja fait pour le centre de la face */

    /******************************  Face Im sur PML Face J*********************/
#pragma omp parallel for private(k) schedule(guided)
    for (j=1; j<(W); j++)
    {
        for (k=0; k<K; k++)
        {

            Tii_I[(0)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                   (1-DeltaT*AttenuationPML[2*0])*Tii_I[(0)*(W+1)*(K)+(j)*(K)+(k)]													+
                                                   DeltaTsurH*TableCii[Carte_Tampon[k]]*(
                                                           SignI*(	(Vi_I[(0)*(W+1)*(K)+(j)*(K)+(k)]	+ Vi_J[(0)*(W+1)*(K)+(j)*(K)+(k)]		+ Vi_K[(0)*(W+1)*(K)+(j)*(K)+(k)]	)
                                                                   -	(Vi_BufferAreteFaceJ[j*(K)+k])	)	)	);

            Tii_J[(0)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                                                   (1-DeltaT*AttenuationPML[2*j])*Tii_J[(0)*(W+1)*(K)+(j)*(K)+(k)]													+
                                                   DeltaTsurH*TableCij[Carte_Tampon[k]]*(
                                                           SignJ*(	(Vj_I[(0)*(W)*(K)+(j)*(K)+(k)]	+ Vj_J[(0)*(W)*(K)+(j)*(K)+(k)]		+ Vj_K[(0)*(W)*(K)+(j)*(K)+(k)])
                                                                   -	(Vj_I[(0)*(W)*(K)+(j-1)*(K)+(k)]+ Vj_J[(0)*(W)*(K)+(j-1)*(K)+(k)]	+ Vj_K[(0)*(W)*(K)+(j-1)*(K)+(k)])	)	)	);

            Tii_K[(0)*(W+1)*(K)+(j)*(K)+(k)] += DeltaTsurH*(
                                                    TableCki[Carte_Tampon[k]]*(
                                                            (Vk_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]+ Vk_J[(0)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	+	Vk_K[(0)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	)
                                                            -	(Vk_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)]	+ Vk_J[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)]		+	Vk_K[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)]	)	)	);



            Tjj_I[(0)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                   (1-DeltaT*AttenuationPML[2*0])*Tjj_I[(0)*(W+1)*(K)+(j)*(K)+(k)]													+
                                                   DeltaTsurH*TableCij[Carte_Tampon[k]]*(
                                                           SignI*(	(Vi_I[(0)*(W+1)*(K)+(j)*(K)+(k)]	+ Vi_J[(0)*(W+1)*(K)+(j)*(K)+(k)]		+ Vi_K[(0)*(W+1)*(K)+(j)*(K)+(k)]	)
                                                                   -	(Vi_BufferAreteFaceJ[j*(K)+k])	)	)	);

            Tjj_J[(0)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                                                   (1-DeltaT*AttenuationPML[2*j])*Tjj_J[(0)*(W+1)*(K)+(j)*(K)+(k)]													+
                                                   DeltaTsurH*TableCjj[Carte_Tampon[k]]*(
                                                           SignJ*(	(Vj_I[(0)*(W)*(K)+(j)*(K)+(k)]	+ Vj_J[(0)*(W)*(K)+(j)*(K)+(k)]		+ Vj_K[(0)*(W)*(K)+(j)*(K)+(k)])
                                                                   -	(Vj_I[(0)*(W)*(K)+(j-1)*(K)+(k)]+ Vj_J[(0)*(W)*(K)+(j-1)*(K)+(k)]	+ Vj_K[(0)*(W)*(K)+(j-1)*(K)+(k)])	)	)	);

            Tjj_K[(0)*(W+1)*(K)+(j)*(K)+(k)] += DeltaTsurH*(
                                                    TableCjk[Carte_Tampon[k]]*(
                                                            (Vk_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]+ Vk_J[(0)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	+	Vk_K[(0)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	)
                                                            -	(Vk_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)]	+ Vk_J[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)]		+	Vk_K[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)]	)	)	);



            Tkk_I[(0)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                   (1-DeltaT*AttenuationPML[2*0])*Tkk_I[(0)*(W+1)*(K)+(j)*(K)+(k)]													+
                                                   DeltaTsurH*TableCki[Carte_Tampon[k]]*(
                                                           SignI*(	(Vi_I[(0)*(W+1)*(K)+(j)*(K)+(k)]	+ Vi_J[(0)*(W+1)*(K)+(j)*(K)+(k)]		+ Vi_K[(0)*(W+1)*(K)+(j)*(K)+(k)]	)
                                                                   -	(Vi_BufferAreteFaceJ[j*(K)+k])	)	)	);

            Tkk_J[(0)*(W+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                                                   (1-DeltaT*AttenuationPML[2*j])*Tkk_J[(0)*(W+1)*(K)+(j)*(K)+(k)]													+
                                                   DeltaTsurH*TableCjk[Carte_Tampon[k]]*(
                                                           SignJ*(	(Vj_I[(0)*(W)*(K)+(j)*(K)+(k)]	+ Vj_J[(0)*(W)*(K)+(j)*(K)+(k)]		+ Vj_K[(0)*(W)*(K)+(j)*(K)+(k)])
                                                                   -	(Vj_I[(0)*(W)*(K)+(j-1)*(K)+(k)]+ Vj_J[(0)*(W)*(K)+(j-1)*(K)+(k)]	+ Vj_K[(0)*(W)*(K)+(j-1)*(K)+(k)])	)	)	);

            Tkk_K[(0)*(W+1)*(K)+(j)*(K)+(k)] += DeltaTsurH*(
                                                    TableCkk[Carte_Tampon[k]]*(
                                                            (Vk_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]+ Vk_J[(0)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	+	Vk_K[(0)*(W+1)*(K+1)+(j)*(K+1)+(k+1)]	)
                                                            -	(Vk_I[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)]	+ Vk_J[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)]		+	Vk_K[(0)*(W+1)*(K+1)+(j)*(K+1)+(k)]	)	)	);

        }
    }

    /*rq: si il y a un bug dans un des 3 Tii, comme c'est fait par copier/coller, ne pas oublier de tout corriger...*/

    /*Tjk est deja fait ....*/

    /*   Arete	Face I/Face J 	*/


#pragma omp parallel for schedule(guided)
    for (k=0; k<K; k++)
    {

        Tii_I[(0)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                               (1-DeltaT*AttenuationPML[2*0])*Tii_I[(0)*(W+1)*(K)+(0)*(K)+(k)]													+
                                               DeltaTsurH*TableCii[Carte_Tampon[k]]*(
                                                       SignI*(	(Vi_I[(0)*(W+1)*(K)+(0)*(K)+(k)]	+ Vi_J[(0)*(W+1)*(K)+(0)*(K)+(k)]		+ Vi_K[(0)*(W+1)*(K)+(0)*(K)+(k)]	)
                                                               -	(Vi_BufferAreteFaceJ[0*(K)+k])	)	)	);

        Tii_J[(0)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                               (1-DeltaT*AttenuationPML[2*0])*Tii_J[(0)*(W+1)*(K)+(0)*(K)+(k)]													+
                                               DeltaTsurH*TableCij[Carte_Tampon[k]]*(
                                                       SignJ*(	(Vj_I[(0)*(W)*(K)+(0)*(K)+(k)]	+ Vj_J[(0)*(W)*(K)+(0)*(K)+(k)]		+ Vj_K[(0)*(W)*(K)+(0)*(K)+(k)]	)
                                                               -	(Vj_BufferAreteFaceI[0*(K)+k])																																		)	)	);

        Tii_K[(0)*(W+1)*(K)+(0)*(K)+(k)] += DeltaTsurH*(
                                                TableCki[Carte_Tampon[k]]*(
                                                        (Vk_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]+ Vk_J[(0)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	+	Vk_K[(0)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	)
                                                        -	(Vk_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)]	+ Vk_J[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)]		+	Vk_K[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)]	)	)	);



        Tjj_I[(0)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                               (1-DeltaT*AttenuationPML[2*0])*Tjj_I[(0)*(W+1)*(K)+(0)*(K)+(k)]													+
                                               DeltaTsurH*TableCij[Carte_Tampon[k]]*(
                                                       SignI*(	(Vi_I[(0)*(W+1)*(K)+(0)*(K)+(k)]	+ Vi_J[(0)*(W+1)*(K)+(0)*(K)+(k)]		+ Vi_K[(0)*(W+1)*(K)+(0)*(K)+(k)]	)
                                                               -	(Vi_BufferAreteFaceJ[0*(K)+k])	)	)	);

        Tjj_J[(0)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                               (1-DeltaT*AttenuationPML[2*0])*Tjj_J[(0)*(W+1)*(K)+(0)*(K)+(k)]													+
                                               DeltaTsurH*TableCjj[Carte_Tampon[k]]*(
                                                       SignJ*(	(Vj_I[(0)*(W)*(K)+(0)*(K)+(k)]	+ Vj_J[(0)*(W)*(K)+(0)*(K)+(k)]		+ Vj_K[(0)*(W)*(K)+(0)*(K)+(k)]	)
                                                               -	(Vj_BufferAreteFaceI[0*(K)+k])																																		)	)	);

        Tjj_K[(0)*(W+1)*(K)+(0)*(K)+(k)] += DeltaTsurH*(
                                                TableCjk[Carte_Tampon[k]]*(
                                                        (Vk_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]+ Vk_J[(0)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	+	Vk_K[(0)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	)
                                                        -	(Vk_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)]	+ Vk_J[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)]		+	Vk_K[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)]	)	)	);


        Tkk_I[(0)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                               (1-DeltaT*AttenuationPML[2*0])*Tkk_I[(0)*(W+1)*(K)+(0)*(K)+(k)]													+
                                               DeltaTsurH*TableCki[Carte_Tampon[k]]*(
                                                       SignI*(	(Vi_I[(0)*(W+1)*(K)+(0)*(K)+(k)]	+ Vi_J[(0)*(W+1)*(K)+(0)*(K)+(k)]		+ Vi_K[(0)*(W+1)*(K)+(0)*(K)+(k)]	)
                                                               -	(Vi_BufferAreteFaceJ[0*(K)+k])	)	)	);

        Tkk_J[(0)*(W+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                               (1-DeltaT*AttenuationPML[2*0])*Tkk_J[(0)*(W+1)*(K)+(0)*(K)+(k)]													+
                                               DeltaTsurH*TableCjk[Carte_Tampon[k]]*(
                                                       SignJ*(	(Vj_I[(0)*(W)*(K)+(0)*(K)+(k)]	+ Vj_J[(0)*(W)*(K)+(0)*(K)+(k)]		+ Vj_K[(0)*(W)*(K)+(0)*(K)+(k)]	)
                                                               -	(Vj_BufferAreteFaceI[0*(K)+k])																																		)	)	);

        Tkk_K[(0)*(W+1)*(K)+(0)*(K)+(k)] += DeltaTsurH*(
                                                TableCkk[Carte_Tampon[k]]*(
                                                        (Vk_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]+ Vk_J[(0)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	+	Vk_K[(0)*(W+1)*(K+1)+(0)*(K+1)+(k+1)]	)
                                                        -	(Vk_I[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)]	+ Vk_J[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)]		+	Vk_K[(0)*(W+1)*(K+1)+(0)*(K+1)+(k)]	)	)	);
    }
    /*rq: si il y a un bug dans un des 3 Tii, comme c'est fait par copier/coller, ne pas oublier de tout corriger...*/
    /*Tjk est deja fait, pour le centre de la face*/

    /******************************  Face Kp sur PML Coin Kp*********************/
    /********  les aretes sont prises en compte dans ces face *******************/

    if(
        ((!strcmp(TypeArete,"XpYp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XpYm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XmYp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"XmYm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeArete,"YpZp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YpZm"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YmZp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"YmZm"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeArete,"ZpXp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZpXm"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZmXp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeArete,"ZmXm"))&&(ConditionFaceYp==0))
    )
    {

#pragma omp parallel for private(j,Cjkjk) schedule(guided)
        for (i=0; i<(W+1); i++)
        {
            for (j=0; j<W; j++)
            {

                Cjkjk=TableCjkjk[Carte_Tampon[(K-1)]];

                Tjk_J[(i)*(W)*(K+1)+(j)*(K+1)+(K)] = 1./(1+DeltaT*AttenuationPML[1+2*j])*	(
                        (1-DeltaT*AttenuationPML[1+2*j])*Tjk_J[(i)*(W)*(K+1)+(j)*(K+1)+(K)]											+
                        DeltaTsurH*Cjkjk*(
                            SignJ*(	(Vk_I[(i)*(W+1)*(K+1)+(j+1)*(K+1)+(K)]+	Vk_J[(i)*(W+1)*(K+1)+(j+1)*(K+1)+(K)]+Vk_K[(i)*(W+1)*(K+1)+(j+1)*(K+1)+(K)])
                                    -	(Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)]	+	Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)]	+	Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)])	)	)	);

                Tjk_K[(i)*(W)*(K+1)+(j)*(K+1)+(K)] += DeltaTsurH*Cjkjk*(
                        (	(Vj_BufferAreteCoinKp[i*(W)+j]	)
                            -	(Vj_I[(i)*(W)*(K)+(j)*(K)+(K-1)]	+Vj_J[(i)*(W)*(K)+(j)*(K)+(K-1)]	+Vj_K[(i)*(W)*(K)+(j)*(K)+(K-1)])	)	);
            }
        }


#pragma omp parallel for private(j,Ckiki) schedule(guided)
        for (i=0; i<W; i++)
        {
            for (j=0; j<(W+1); j++)
            {

                Ckiki=TableCkiki[Carte_Tampon[(K-1)]];

                Tki_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*	(
                        (1-DeltaT*AttenuationPML[1+2*i])*Tki_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)]													+
                        DeltaTsurH*Ckiki*(
                            SignI*(	(Vk_I[(i+1)*(W+1)*(K+1)+(j)*(K+1)+(K)]	+Vk_J[(i+1)*(W+1)*(K+1)+(j)*(K+1)+(K)]	+Vk_K[(i+1)*(W+1)*(K+1)+(j)*(K+1)+(K)])
                                    -	(Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)]		+Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)]		+Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)])	)	)	);

                Tki_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(K)] += DeltaTsurH*Ckiki*(
                        (	(Vi_BufferAreteCoinKp[i*(W+1)+j])
                            -	(Vi_I[(i)*(W+1)*(K)+(j)*(K)+(K-1)]+Vi_J[(i)*(W+1)*(K)+(j)*(K)+(K-1)]+Vi_K[(i)*(W+1)*(K)+(j)*(K)+(K-1)]) )	);

            }
        }
    }
    /*Cas de la symetrie est implicite*/
    /******************************  Face Km sur PML Coin Km*********************/
    /********  les aretes sont prises en compte dans ces face *******************/
    if(
        ((!strcmp(TypeArete,"XpYp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XpYm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XmYp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"XmYm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeArete,"YpZp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YpZm"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YmZp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"YmZm"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeArete,"ZpXp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZpXm"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZmXp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeArete,"ZmXm"))&&(ConditionFaceYm==0))
    )
    {
#pragma omp parallel for private(j,Cjkjk) schedule(guided)
        for (i=0; i<(W+1); i++)
        {
            for (j=0; j<W; j++)
            {

                Cjkjk=TableCjkjk[Carte_Tampon[(0)]];


                Tjk_J[(i)*(W)*(K+1)+(j)*(K+1)+(0)] = 1./(1+DeltaT*AttenuationPML[1+2*j])*	(
                        (1-DeltaT*AttenuationPML[1+2*j])*Tjk_J[(i)*(W)*(K+1)+(j)*(K+1)+(0)]											+
                        DeltaTsurH*Cjkjk*(
                            SignJ*(	(Vk_I[(i)*(W+1)*(K+1)+(j+1)*(K+1)+(0)]+	Vk_J[(i)*(W+1)*(K+1)+(j+1)*(K+1)+(0)]+Vk_K[(i)*(W+1)*(K+1)+(j+1)*(K+1)+(0)])
                                    -	(Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)]	+	Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)]	+	Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)])	)	)	);

                Tjk_K[(i)*(W)*(K+1)+(j)*(K+1)+(0)] += DeltaTsurH*Cjkjk*(
                        (	(Vj_I[(i)*(W)*(K)+(j)*(K)+(0)]		+Vj_J[(i)*(W)*(K)+(j)*(K)+(0)]		+Vj_K[(i)*(W)*(K)+(j)*(K)+(0)]	)
                            -	(Vj_BufferAreteCoinKm[i*(W)+j])	)	);
            }
        }

#pragma omp parallel for private(j,Ckiki) schedule(guided)
        for (i=0; i<W; i++)
        {
            for (j=0; j<(W+1); j++)
            {

                Ckiki=TableCkiki[Carte_Tampon[(0)]];

                Tki_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*	(
                        (1-DeltaT*AttenuationPML[1+2*i])*Tki_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)]													+
                        DeltaTsurH*Ckiki*(
                            SignI*(	(Vk_I[(i+1)*(W+1)*(K+1)+(j)*(K+1)+(0)]	+Vk_J[(i+1)*(W+1)*(K+1)+(j)*(K+1)+(0)]	+Vk_K[(i+1)*(W+1)*(K+1)+(j)*(K+1)+(0)])
                                    -	(Vk_I[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)]		+Vk_J[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)]		+Vk_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)])	)	)	);

                Tki_K[(i)*(W+1)*(K+1)+(j)*(K+1)+(0)] += DeltaTsurH*Ckiki*(
                        (Vi_I[(i)*(W+1)*(K)+(j)*(K)+(0)]	+Vi_J[(i)*(W+1)*(K)+(j)*(K)+(0)]	+Vi_K[(i)*(W+1)*(K)+(j)*(K)+(0)])
                        -	(Vi_BufferAreteCoinKm[i*(W+1)+j])	);
            }
        }
    }
    /*Cas de la symetrie est implicite*/
}
