/* Copyright (C) 2003-2012 BOSSY Emmanuel.

This file is part of the SimSonic suite.

SimSonic is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SimSonic is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SimSonic.  If not, see <http://www.gnu.org/licenses/>. */

void CalculPMLFaceContraintes(PREC_GRILLE *Vi_I,PREC_GRILLE *Vi_JK,
                              PREC_GRILLE *Vj_I,PREC_GRILLE *Vj_JK,
                              PREC_GRILLE *Vk_I,PREC_GRILLE *Vk_JK,
                              PREC_GRILLE *Tii_I,PREC_GRILLE *Tii_JK,
                              PREC_GRILLE *Tjj_I,PREC_GRILLE *Tjj_JK,
                              PREC_GRILLE *Tkk_I,PREC_GRILLE *Tkk_JK,
                              PREC_GRILLE *Tij_I,PREC_GRILLE *Tij_JK,
                              PREC_GRILLE *Tki_I,PREC_GRILLE *Tki_JK,
                              PREC_GRILLE *Tjk,
                              int J, int K,
                              const char *TypeFace)
{


    int i,j,k;
    double Sign;
    double Cjkjk,Ckiki,Cijij;/* (4: jk, 5: ki, 6:ij)*/

    if (!strcmp(TypeFace,"Xp")||!strcmp(TypeFace,"Yp")||!strcmp(TypeFace,"Zp"))
        Sign = +1.0;
    else
        Sign = -1.0;

    /*************************************************************************/
    /***************************  Bloc de la face PML ************************/
    /*************************************************************************/

#pragma omp parallel for private(j,k) schedule(guided)
    for (i=1; i<W; i++)
    {
        for (j=0; j<J; j++)
        {
            for (k=0; k<K; k++)
            {

                Tii_I[(i)*(J)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                     (1-DeltaT*AttenuationPML[2*i])*Tii_I[(i)*(J)*(K)+(j)*(K)+(k)]													+
                                                     DeltaTsurH*TableCii[Carte_Tampon[(j)*(K)+(k)]]*(
                                                             Sign*(	(Vi_I[(i)*(J)*(K)+(j)*(K)+(k)]			+		Vi_JK[(i)*(J)*(K)+(j)*(K)+(k)]	)
                                                                     -	(Vi_I[(i-1)*(J)*(K)+(j)*(K)+(k)]		+		Vi_JK[(i-1)*(J)*(K)+(j)*(K)+(k)])	)	)	);

                Tii_JK[(i)*(J)*(K)+(j)*(K)+(k)] += DeltaTsurH*(
                                                       TableCij[Carte_Tampon[(j)*(K)+(k)]]*(
                                                               (Vj_I[(i)*(J+1)*(K)+(j+1)*(K)+(k)]	+		Vj_JK[(i)*(J+1)*(K)+(j+1)*(K)+(k)]	)
                                                               -	(Vj_I[(i)*(J+1)*(K)+(j)*(K)+(k)]		+		Vj_JK[(i)*(J+1)*(K)+(j)*(K)+(k)]		)	)	+
                                                       TableCki[Carte_Tampon[(j)*(K)+(k)]]*(
                                                               (Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(k+1)]+		Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(k+1)])
                                                               -	(Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(k)]	+		Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(k)]	)	)	);

                Tjj_I[(i)*(J)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                     (1-DeltaT*AttenuationPML[2*i])*Tjj_I[(i)*(J)*(K)+(j)*(K)+(k)]													+
                                                     DeltaTsurH*TableCij[Carte_Tampon[(j)*(K)+(k)]]*(
                                                             Sign*(	(Vi_I[(i)*(J)*(K)+(j)*(K)+(k)]			+		Vi_JK[(i)*(J)*(K)+(j)*(K)+(k)]	)
                                                                     -	(Vi_I[(i-1)*(J)*(K)+(j)*(K)+(k)]		+		Vi_JK[(i-1)*(J)*(K)+(j)*(K)+(k)])	)	)	);

                Tjj_JK[(i)*(J)*(K)+(j)*(K)+(k)] += DeltaTsurH*(
                                                       TableCjj[Carte_Tampon[(j)*(K)+(k)]]*(
                                                               (Vj_I[(i)*(J+1)*(K)+(j+1)*(K)+(k)]		+		Vj_JK[(i)*(J+1)*(K)+(j+1)*(K)+(k)]	)
                                                               -	(Vj_I[(i)*(J+1)*(K)+(j)*(K)+(k)]			+		Vj_JK[(i)*(J+1)*(K)+(j)*(K)+(k)]		)	)	+
                                                       TableCjk[Carte_Tampon[(j)*(K)+(k)]]*(
                                                               (Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(k+1)]	+		Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(k+1)])
                                                               -	(Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(k)]		+		Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(k)]	)	)	);

                Tkk_I[(i)*(J)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                     (1-DeltaT*AttenuationPML[2*i])*Tkk_I[(i)*(J)*(K)+(j)*(K)+(k)]													+
                                                     DeltaTsurH*TableCki[Carte_Tampon[(j)*(K)+(k)]]*(
                                                             Sign*(	(Vi_I[(i)*(J)*(K)+(j)*(K)+(k)]			+		Vi_JK[(i)*(J)*(K)+(j)*(K)+(k)]	)
                                                                     -	(Vi_I[(i-1)*(J)*(K)+(j)*(K)+(k)]		+		Vi_JK[(i-1)*(J)*(K)+(j)*(K)+(k)])	)	)	);

                Tkk_JK[(i)*(J)*(K)+(j)*(K)+(k)] += DeltaTsurH*(
                                                       TableCjk[Carte_Tampon[(j)*(K)+(k)]]*(
                                                               (Vj_I[(i)*(J+1)*(K)+(j+1)*(K)+(k)]		+		Vj_JK[(i)*(J+1)*(K)+(j+1)*(K)+(k)]	)
                                                               -	(Vj_I[(i)*(J+1)*(K)+(j)*(K)+(k)]			+		Vj_JK[(i)*(J+1)*(K)+(j)*(K)+(k)]		)	)	+
                                                       TableCkk[Carte_Tampon[(j)*(K)+(k)]]*(
                                                               (Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(k+1)]	+		Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(k+1)])
                                                               -	(Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(k)]		+		Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(k)]	)	)	);

            }
        }
    }


#pragma omp parallel for private(j,k,Cijij) schedule(guided)
    for (i=0; i<W; i++)
    {
        for (j=1; j<J; j++)
        {
            for (k=0; k<K; k++)
            {

                if (TableCijij[Carte_Tampon[(j-1)*(K)+(k)]]*
                        TableCijij[Carte_Tampon[(j)*(K)+(k)]])
                {

                    Cijij=2./(1./TableCijij[Carte_Tampon[(j-1)*(K)+(k)]]+
                              1./TableCijij[Carte_Tampon[(j)*(K)+(k)]]);
                }
                else
                {
                    Cijij=0.0;
                }

                Tij_I[(i)*(J+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*	(
                                                       (1-DeltaT*AttenuationPML[1+2*i])*Tij_I[(i)*(J+1)*(K)+(j)*(K)+(k)]											+
                                                       DeltaTsurH*Cijij*(
                                                               Sign*(	(Vj_I[(i+1)*(J+1)*(K)+(j)*(K)+(k)]	+		Vj_JK[(i+1)*(J+1)*(K)+(j)*(K)+(k)])
                                                                       -	(Vj_I[(i)*(J+1)*(K)+(j)*(K)+(k)]		+		Vj_JK[(i)*(J+1)*(K)+(j)*(K)+(k)]	)	)	)	);

                Tij_JK[(i)*(J+1)*(K)+(j)*(K)+(k)] += DeltaTsurH*Cijij*(
                        (Vi_I[(i)*(J)*(K)+(j)*(K)+(k)]		+	Vi_JK[(i)*(J)*(K)+(j)*(K)+(k)]		)
                        -	(Vi_I[(i)*(J)*(K)+(j-1)*(K)+(k)]	+	Vi_JK[(i)*(J)*(K)+(j-1)*(K)+(k)]	)	);
            }
        }
    }

#pragma omp parallel for private(j,k,Cjkjk) schedule(guided)
    for (i=0; i<W; i++)
    {
        for (j=1; j<J; j++)
        {
            for (k=1; k<K; k++)
            {

                if (TableCjkjk[Carte_Tampon[(j-1)*(K)+(k-1)]]*
                        TableCjkjk[Carte_Tampon[(j-1)*(K)+(k)]]*
                        TableCjkjk[Carte_Tampon[(j)*(K)+(k-1)]]*
                        TableCjkjk[Carte_Tampon[(j)*(K)+(k)]])
                {

                    Cjkjk=4./(1./TableCjkjk[Carte_Tampon[(j-1)*(K)+(k-1)]]+
                              1./TableCjkjk[Carte_Tampon[(j-1)*(K)+(k)]]+
                              1./TableCjkjk[Carte_Tampon[(j)*(K)+(k-1)]]+
                              1./TableCjkjk[Carte_Tampon[(j)*(K)+(k)]]);
                }
                else
                {
                    Cjkjk=0.0;
                }

                Tjk[(i)*(J+1)*(K+1)+(j)*(K+1)+(k)] += DeltaTsurH*Cjkjk*(
                        (	(Vj_I[(i)*(J+1)*(K)+(j)*(K)+(k)]			+	Vj_JK[(i)*(J+1)*(K)+(j)*(K)+(k)]		)
                            -	(Vj_I[(i)*(J+1)*(K)+(j)*(K)+(k-1)]		+	Vj_JK[(i)*(J+1)*(K)+(j)*(K)+(k-1)]	)	)	+
                        (	(Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(k)]		+	Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(k)]	)
                            -	(Vk_I[(i)*(J)*(K+1)+(j-1)*(K+1)+(k)]	+	Vk_JK[(i)*(J)*(K+1)+(j-1)*(K+1)+(k)])	)	);
            }
        }
    }

#pragma omp parallel for private(j,k,Ckiki) schedule(guided)
    for (i=0; i<W; i++)
    {
        for (j=0; j<J; j++)
        {
            for (k=1; k<K; k++)
            {

                if (TableCkiki[Carte_Tampon[(j)*(K)+(k-1)]]*
                        TableCkiki[Carte_Tampon[(j)*(K)+(k)]])
                {

                    Ckiki=2./(1./TableCkiki[Carte_Tampon[(j)*(K)+(k-1)]]+
                              1./TableCkiki[Carte_Tampon[(j)*(K)+(k)]]);
                }
                else
                {
                    Ckiki=0.0;
                }


                Tki_I[(i)*(J)*(K+1)+(j)*(K+1)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*	(
                        (1-DeltaT*AttenuationPML[1+2*i])*Tki_I[(i)*(J)*(K+1)+(j)*(K+1)+(k)]													+
                        DeltaTsurH*Ckiki*(
                            Sign*(	(Vk_I[(i+1)*(J)*(K+1)+(j)*(K+1)+(k)]	+		Vk_JK[(i+1)*(J)*(K+1)+(j)*(K+1)+(k)])
                                    -	(Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(k)]		+		Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(k)]	)	)	)	);

                Tki_JK[(i)*(J)*(K+1)+(j)*(K+1)+(k)] += DeltaTsurH*Ckiki*(
                        (Vi_I[(i)*(J)*(K)+(j)*(K)+(k)]		+	Vi_JK[(i)*(J)*(K)+(j)*(K)+(k)]		)
                        -	(Vi_I[(i)*(J)*(K)+(j)*(K)+(k-1)]	+	Vi_JK[(i)*(J)*(K)+(j)*(K)+(k-1)]	)	);

            }
        }
    }

    /*************************************************************************/
    /*********************** Calcul des faces de la face PML *****************/
    /*************************************************************************/

    /************************* Face Im (contre le bloc central) **************/

#pragma omp parallel for private(k) schedule(guided)
    for (j=0; j<J; j++)
    {
        for (k=0; k<K; k++)
        {

            Tii_I[(0)*(J)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                 (1-DeltaT*AttenuationPML[2*0])*Tii_I[(0)*(J)*(K)+(j)*(K)+(k)]												+
                                                 DeltaTsurH*TableCii[Carte_Tampon[(j)*(K)+(k)]]*(
                                                         Sign*(	(Vi_I[(0)*(J)*(K)+(j)*(K)+(k)]			+	Vi_JK[(0)*(J)*(K)+(j)*(K)+(k)]	)
                                                                 -	(Vi_BufferFaceBlocI[(j)*(K)+(k)]																								)	)	)	);

            Tii_JK[(0)*(J)*(K)+(j)*(K)+(k)] += DeltaTsurH*(
                                                   TableCij[Carte_Tampon[(j)*(K)+(k)]]*(
                                                           (Vj_I[(0)*(J+1)*(K)+(j+1)*(K)+(k)]	+	Vj_JK[(0)*(J+1)*(K)+(j+1)*(K)+(k)]	)
                                                           -	(Vj_I[(0)*(J+1)*(K)+(j)*(K)+(k)]		+	Vj_JK[(0)*(J+1)*(K)+(j)*(K)+(k)]		)	)	+
                                                   TableCki[Carte_Tampon[(j)*(K)+(k)]]*(
                                                           (Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(k+1)]+	Vk_JK[(0)*(J)*(K+1)+(j)*(K+1)+(k+1)])
                                                           -	(Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(k)]	+	Vk_JK[(0)*(J)*(K+1)+(j)*(K+1)+(k)]	)	)	);

            Tjj_I[(0)*(J)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                 (1-DeltaT*AttenuationPML[2*0])*Tjj_I[(0)*(J)*(K)+(j)*(K)+(k)]												+
                                                 DeltaTsurH*TableCij[Carte_Tampon[(j)*(K)+(k)]]*(
                                                         Sign*(	(Vi_I[(0)*(J)*(K)+(j)*(K)+(k)]			+	Vi_JK[(0)*(J)*(K)+(j)*(K)+(k)]	)
                                                                 -	(Vi_BufferFaceBlocI[(j)*(K)+(k)]																								)	)	)	);

            Tjj_JK[(0)*(J)*(K)+(j)*(K)+(k)] += DeltaTsurH*(
                                                   TableCjj[Carte_Tampon[(j)*(K)+(k)]]*(
                                                           (Vj_I[(0)*(J+1)*(K)+(j+1)*(K)+(k)]	+	Vj_JK[(0)*(J+1)*(K)+(j+1)*(K)+(k)]	)
                                                           -	(Vj_I[(0)*(J+1)*(K)+(j)*(K)+(k)]		+	Vj_JK[(0)*(J+1)*(K)+(j)*(K)+(k)]		)	)	+
                                                   TableCjk[Carte_Tampon[(j)*(K)+(k)]]*(
                                                           (Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(k+1)]+	Vk_JK[(0)*(J)*(K+1)+(j)*(K+1)+(k+1)])
                                                           -	(Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(k)]	+	Vk_JK[(0)*(J)*(K+1)+(j)*(K+1)+(k)]	)	)	);

            Tkk_I[(0)*(J)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                 (1-DeltaT*AttenuationPML[2*0])*Tkk_I[(0)*(J)*(K)+(j)*(K)+(k)]											+
                                                 DeltaTsurH*TableCki[Carte_Tampon[(j)*(K)+(k)]]*(
                                                         Sign*(	(Vi_I[(0)*(J)*(K)+(j)*(K)+(k)]			+	Vi_JK[(0)*(J)*(K)+(j)*(K)+(k)])
                                                                 -	(Vi_BufferFaceBlocI[(j)*(K)+(k)]																							)	)	)	);

            Tkk_JK[(0)*(J)*(K)+(j)*(K)+(k)] += DeltaTsurH*																		(
                                                   TableCjk[Carte_Tampon[(j)*(K)+(k)]]*(
                                                           (Vj_I[(0)*(J+1)*(K)+(j+1)*(K)+(k)]	+	Vj_JK[(0)*(J+1)*(K)+(j+1)*(K)+(k)]	)
                                                           -	(Vj_I[(0)*(J+1)*(K)+(j)*(K)+(k)]		+	Vj_JK[(0)*(J+1)*(K)+(j)*(K)+(k)]		)	)	+
                                                   TableCkk[Carte_Tampon[(j)*(K)+(k)]]*(
                                                           (Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(k+1)]+	Vk_JK[(0)*(J)*(K+1)+(j)*(K+1)+(k+1)])
                                                           -	(Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(k)]	+	Vk_JK[(0)*(J)*(K+1)+(j)*(K+1)+(k)]	)	)	);

        }
    }		/*la variable jk a dja t traite dans le cas du bloc central.... pas de pb sur le
				centre de la face (pas de drive selon I)*/

    /**********************************  Face contre arete Jp ***************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXp==0))
    )
    {

#pragma omp parallel for private(k,Cijij) schedule(guided)
        for (i=0; i<W; i++)
        {
            for (k=0; k<K; k++)
            {

                Cijij=TableCijij[Carte_Tampon[(J-1)*(K)+(k)]];


                Tij_I[(i)*(J+1)*(K)+(J)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*	(
                                                       (1-DeltaT*AttenuationPML[1+2*i])*Tij_I[(i)*(J+1)*(K)+(J)*(K)+(k)]											+
                                                       DeltaTsurH*Cijij*(
                                                               Sign*(	(Vj_I[(i+1)*(J+1)*(K)+(J)*(K)+(k)]	+		Vj_JK[(i+1)*(J+1)*(K)+(J)*(K)+(k)])
                                                                       -	(Vj_I[(i)*(J+1)*(K)+(J)*(K)+(k)]		+		Vj_JK[(i)*(J+1)*(K)+(J)*(K)+(k)]	)	)	)	);

                Tij_JK[(i)*(J+1)*(K)+(J)*(K)+(k)] += DeltaTsurH*Cijij*(
                        (Vi_BufferFaceAreteJp[i*(K)+k])
                        -	(Vi_I[(i)*(J)*(K)+(J-1)*(K)+(k)]		+Vi_JK[(i)*(J)*(K)+(J-1)*(K)+(k)]	)	);
            }
        }
#pragma omp parallel for private(k,Cjkjk) schedule(guided)
        for (i=1; i<W; i++)
        {
            for (k=1; k<K; k++)
            {

                if (TableCjkjk[Carte_Tampon[(J-1)*(K)+(k-1)]]*
                        TableCjkjk[Carte_Tampon[(J-1)*(K)+(k)]])
                {

                    Cjkjk=2./(1./TableCjkjk[Carte_Tampon[(J-1)*(K)+(k-1)]]+
                              1./TableCjkjk[Carte_Tampon[(J-1)*(K)+(k)]]);
                }
                else
                {
                    Cjkjk=0.0;
                }

                Tjk[(i)*(J+1)*(K+1)+(J)*(K+1)+(k)] += DeltaTsurH*Cjkjk*(
                        (	(Vj_I[(i)*(J+1)*(K)+(J)*(K)+(k)]			+	Vj_JK[(i)*(J+1)*(K)+(J)*(K)+(k)]		)
                            -	(Vj_I[(i)*(J+1)*(K)+(J)*(K)+(k-1)]		+	Vj_JK[(i)*(J+1)*(K)+(J)*(K)+(k-1)]	)	)	+
                        (	(Vk_BufferFaceAreteJp[i*(K+1)+k])
                            -	(Vk_I[(i)*(J)*(K+1)+(J-1)*(K+1)+(k)]	+	Vk_JK[(i)*(J)*(K+1)+(J-1)*(K+1)+(k)])	)	);
            }
        }
    }
    /*Cas de la symetrie est implicite*/
    /**********************************  Face contre arete Jm ***************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXm==0))
    )
    {

#pragma omp parallel for private(k,Cijij) schedule(guided)
        for (i=0; i<W; i++)
        {
            for (k=0; k<K; k++)
            {

                Cijij=TableCijij[Carte_Tampon[(k)]];


                Tij_I[(i)*(J+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*	(
                                                       (1-DeltaT*AttenuationPML[1+2*i])*Tij_I[(i)*(J+1)*(K)+(0)*(K)+(k)]											+
                                                       DeltaTsurH*Cijij*(
                                                               Sign*(	(Vj_I[(i+1)*(J+1)*(K)+(0)*(K)+(k)]	+		Vj_JK[(i+1)*(J+1)*(K)+(0)*(K)+(k)])
                                                                       -	(Vj_I[(i)*(J+1)*(K)+(0)*(K)+(k)]		+		Vj_JK[(i)*(J+1)*(K)+(0)*(K)+(k)]	)	)	)	);

                Tij_JK[(i)*(J+1)*(K)+(0)*(K)+(k)] += DeltaTsurH*Cijij*(
                        (Vi_I[(i)*(J)*(K)+(0)*(K)+(k)]		+	Vi_JK[(i)*(J)*(K)+(0)*(K)+(k)]		)
                        -	(Vi_BufferFaceAreteJm[i*(K)+k])	);
            }
        }

#pragma omp parallel for private(k,Cjkjk) schedule(guided)
        for (i=1; i<W; i++)
        {
            for (k=1; k<K; k++)
            {

                if (TableCjkjk[Carte_Tampon[(0)*(K)+(k-1)]]*
                        TableCjkjk[Carte_Tampon[(0)*(K)+(k)]])
                {

                    Cjkjk=2./(1./TableCjkjk[Carte_Tampon[(0)*(K)+(k-1)]]+
                              1./TableCjkjk[Carte_Tampon[(0)*(K)+(k)]]);
                }
                else
                {
                    Cjkjk=0.0;
                }

                Tjk[(i)*(J+1)*(K+1)+(0)*(K+1)+(k)] += DeltaTsurH*Cjkjk*(
                        (	(Vj_I[(i)*(J+1)*(K)+(0)*(K)+(k)]			+	Vj_JK[(i)*(J+1)*(K)+(0)*(K)+(k)]		)
                            -	(Vj_I[(i)*(J+1)*(K)+(0)*(K)+(k-1)]		+	Vj_JK[(i)*(J+1)*(K)+(0)*(K)+(k-1)]	)	)	+
                        (	(Vk_I[(i)*(J)*(K+1)+(0)*(K+1)+(k)]		+	Vk_JK[(i)*(J)*(K+1)+(0)*(K+1)+(k)]	)
                            -	(Vk_BufferFaceAreteJm[i*(K+1)+k])	)	);
            }
        }
    }
    /*Cas de la symetrie est implicite*/

    /**********************************  Face contre arete Kp ***************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceYp==0))
    )
    {

#pragma omp parallel for private(j,Cjkjk) schedule(guided)
        for (i=1; i<W; i++)
        {
            for (j=1; j<J; j++)
            {

                if (TableCjkjk[Carte_Tampon[(j-1)*(K)+(K-1)]]*
                        TableCjkjk[Carte_Tampon[(j)*(K)+(K-1)]])
                {

                    Cjkjk=2./(1./TableCjkjk[Carte_Tampon[(j-1)*(K)+(K-1)]]+
                              1./TableCjkjk[Carte_Tampon[(j)*(K)+(K-1)]]);
                }
                else
                {
                    Cjkjk=0.0;
                }

                Tjk[(i)*(J+1)*(K+1)+(j)*(K+1)+(K)] += DeltaTsurH*Cjkjk*(
                        (	(Vj_BufferFaceAreteKp[i*(J+1)+j]																						)
                            -	(Vj_I[(i)*(J+1)*(K)+(j)*(K)+(K-1)]		+	Vj_JK[(i)*(J+1)*(K)+(j)*(K)+(K-1)]	)	)	+
                        (	(Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(K)]		+	Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(K)]	)
                            -	(Vk_I[(i)*(J)*(K+1)+(j-1)*(K+1)+(K)]	+	Vk_JK[(i)*(J)*(K+1)+(j-1)*(K+1)+(K)])	)	);
            }
        }

#pragma omp parallel for private(j,Ckiki) schedule(guided)
        for (i=0; i<W; i++)
        {
            for (j=0; j<J; j++)
            {

                Ckiki=TableCkiki[Carte_Tampon[(j)*(K)+(K-1)]];

                Tki_I[(i)*(J)*(K+1)+(j)*(K+1)+(K)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*	(
                        (1-DeltaT*AttenuationPML[1+2*i])*Tki_I[(i)*(J)*(K+1)+(j)*(K+1)+(K)]													+
                        DeltaTsurH*Ckiki*(
                            Sign*(	(Vk_I[(i+1)*(J)*(K+1)+(j)*(K+1)+(K)]	+		Vk_JK[(i+1)*(J)*(K+1)+(j)*(K+1)+(K)])
                                    -	(Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(K)]		+		Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(K)]	)	)	)	);

                Tki_JK[(i)*(J)*(K+1)+(j)*(K+1)+(K)] += DeltaTsurH*Ckiki*(
                        (Vi_BufferFaceAreteKp[i*(J)+j])
                        -	(Vi_I[(i)*(J)*(K)+(j)*(K)+(K-1)]	+	Vi_JK[(i)*(J)*(K)+(j)*(K)+(K-1)]	)	);

            }
        }
    }
    /*Cas de la symetrie est implicite*/
    /**********************************  Face contre arete Km ***************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceYm==0))
    )
    {

#pragma omp parallel for private(j,Cjkjk) schedule(guided)
        for (i=1; i<W; i++)
        {
            for (j=1; j<J; j++)
            {

                if (TableCjkjk[Carte_Tampon[(j-1)*(K)+(0)]]*
                        TableCjkjk[Carte_Tampon[(j)*(K)+(0)]])
                {

                    Cjkjk=2./(1./TableCjkjk[Carte_Tampon[(j-1)*(K)+(0)]]+
                              1./TableCjkjk[Carte_Tampon[(j)*(K)+(0)]]);
                }
                else
                {
                    Cjkjk=0.0;
                }

                Tjk[(i)*(J+1)*(K+1)+(j)*(K+1)+(0)] += DeltaTsurH*Cjkjk*(
                        (	(Vj_I[(i)*(J+1)*(K)+(j)*(K)+(0)]			+	Vj_JK[(i)*(J+1)*(K)+(j)*(K)+(0)]		)
                            -	(Vj_BufferFaceAreteKm[i*(J+1)+j])	)	+
                        (	(Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(0)]		+	Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(0)]	)
                            -	(Vk_I[(i)*(J)*(K+1)+(j-1)*(K+1)+(0)]	+	Vk_JK[(i)*(J)*(K+1)+(j-1)*(K+1)+(0)])	)	);
            }
        }

#pragma omp parallel for private(j,Ckiki) schedule(guided)
        for (i=0; i<W; i++)
        {
            for (j=0; j<J; j++)
            {

                Ckiki=TableCkiki[Carte_Tampon[(j)*(K)+(0)]];


                Tki_I[(i)*(J)*(K+1)+(j)*(K+1)+(0)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*	(
                        (1-DeltaT*AttenuationPML[1+2*i])*Tki_I[(i)*(J)*(K+1)+(j)*(K+1)+(0)]													+
                        DeltaTsurH*Ckiki*(
                            Sign*(	(Vk_I[(i+1)*(J)*(K+1)+(j)*(K+1)+(0)]	+		Vk_JK[(i+1)*(J)*(K+1)+(j)*(K+1)+(0)])
                                    -	(Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(0)]		+		Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(0)]	)	)	)	);

                Tki_JK[(i)*(J)*(K+1)+(j)*(K+1)+(0)] += DeltaTsurH*Ckiki*(
                        (Vi_I[(i)*(J)*(K)+(j)*(K)+(0)]		+	Vi_JK[(i)*(J)*(K)+(j)*(K)+(0)]		)
                        -	(Vi_BufferFaceAreteKm[i*(J)+j])	);

            }
        }
    }
    /*Cas de la symetrie est implicite*/
    /*************************************************************************/
    /*********************** Calcul des aretes de la face PML ****************/
    /*************************************************************************/

    /*****************************   Arete	Im/Jp *****************************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXp==0))
    )
    {
#pragma omp parallel for private(Cjkjk) schedule(guided)
        for (k=1; k<K; k++)
        {

            if (TableCjkjk[Carte_Tampon[(J-1)*(K)+(k-1)]]*
                    TableCjkjk[Carte_Tampon[(J-1)*(K)+(k)]])
            {

                Cjkjk=2./(1./TableCjkjk[Carte_Tampon[(J-1)*(K)+(k-1)]]+
                          1./TableCjkjk[Carte_Tampon[(J-1)*(K)+(k)]]);
            }
            else
            {
                Cjkjk=0.0;
            }

            Tjk[(0)*(J+1)*(K+1)+(J)*(K+1)+(k)] += DeltaTsurH*Cjkjk*(
                    (	(Vj_I[(0)*(J+1)*(K)+(J)*(K)+(k)]			+	Vj_JK[(0)*(J+1)*(K)+(J)*(K)+(k)]		)
                        -	(Vj_I[(0)*(J+1)*(K)+(J)*(K)+(k-1)]		+	Vj_JK[(0)*(J+1)*(K)+(J)*(K)+(k-1)]	)	)	+
                    (	(Vk_BufferFaceAreteJp[0*(K+1)+k])
                        -	(Vk_I[(0)*(J)*(K+1)+(J-1)*(K+1)+(k)]	+	Vk_JK[(0)*(J)*(K+1)+(J-1)*(K+1)+(k)])	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*****************************   Arete	Im/Jm *****************************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXm==0))
    )
    {


#pragma omp parallel for private(Cjkjk) schedule(guided)
        for (k=1; k<K; k++)
        {

            if (TableCjkjk[Carte_Tampon[(0)*(K)+(k-1)]]*
                    TableCjkjk[Carte_Tampon[(0)*(K)+(k)]])
            {

                Cjkjk=2./(1./TableCjkjk[Carte_Tampon[(0)*(K)+(k-1)]]+
                          1./TableCjkjk[Carte_Tampon[(0)*(K)+(k)]]);
            }
            else
            {
                Cjkjk=0.0;
            }

            Tjk[(0)*(J+1)*(K+1)+(0)*(K+1)+(k)] += DeltaTsurH*Cjkjk*(
                    (	(Vj_I[(0)*(J+1)*(K)+(0)*(K)+(k)]			+	Vj_JK[(0)*(J+1)*(K)+(0)*(K)+(k)]		)
                        -	(Vj_I[(0)*(J+1)*(K)+(0)*(K)+(k-1)]		+	Vj_JK[(0)*(J+1)*(K)+(0)*(K)+(k-1)]	)	)	+
                    (	(Vk_I[(0)*(J)*(K+1)+(0)*(K+1)+(k)]		+	Vk_JK[(0)*(J)*(K+1)+(0)*(K+1)+(k)]	)
                        -	(Vk_BufferFaceAreteJm[0*(K+1)+k])	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*****************************   Arete	Im/Kp *****************************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceYp==0))
    )
    {
#pragma omp parallel for private(Cjkjk) schedule(guided)
        for (j=1; j<J; j++)
        {

            if (TableCjkjk[Carte_Tampon[(j-1)*(K)+(K-1)]]*
                    TableCjkjk[Carte_Tampon[(j)*(K)+(K-1)]])
            {

                Cjkjk=2./(1./TableCjkjk[Carte_Tampon[(j-1)*(K)+(K-1)]]+
                          1./TableCjkjk[Carte_Tampon[(j)*(K)+(K-1)]]);
            }
            else
            {
                Cjkjk=0.0;
            }

            Tjk[(0)*(J+1)*(K+1)+(j)*(K+1)+(K)] += DeltaTsurH*Cjkjk*(
                    (	(Vj_BufferFaceAreteKp[0*(J+1)+j]																						)
                        -	(Vj_I[(0)*(J+1)*(K)+(j)*(K)+(K-1)]		+	Vj_JK[(0)*(J+1)*(K)+(j)*(K)+(K-1)]	)	)	+
                    (	(Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(K)]		+	Vk_JK[(0)*(J)*(K+1)+(j)*(K+1)+(K)]	)
                        -	(Vk_I[(0)*(J)*(K+1)+(j-1)*(K+1)+(K)]	+	Vk_JK[(0)*(J)*(K+1)+(j-1)*(K+1)+(K)])	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*****************************   Arete	Im/Km *****************************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceYm==0))
    )
    {
#pragma omp parallel for private(Cjkjk) schedule(guided)
        for (j=1; j<J; j++)
        {

            if (TableCjkjk[Carte_Tampon[(j-1)*(K)+(0)]]*
                    TableCjkjk[Carte_Tampon[(j)*(K)+(0)]])
            {

                Cjkjk=2./(1./TableCjkjk[Carte_Tampon[(j-1)*(K)+(0)]]+
                          1./TableCjkjk[Carte_Tampon[(j)*(K)+(0)]]);
            }
            else
            {
                Cjkjk=0.0;
            }

            Tjk[(0)*(J+1)*(K+1)+(j)*(K+1)+(0)] += DeltaTsurH*Cjkjk*(
                    (	(Vj_I[(0)*(J+1)*(K)+(j)*(K)+(0)]			+	Vj_JK[(0)*(J+1)*(K)+(j)*(K)+(0)]		)
                        -	(Vj_BufferFaceAreteKm[0*(J+1)+j])	)	+
                    (	(Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(0)]		+	Vk_JK[(0)*(J)*(K+1)+(j)*(K+1)+(0)]	)
                        -	(Vk_I[(0)*(J)*(K+1)+(j-1)*(K+1)+(0)]	+	Vk_JK[(0)*(J)*(K+1)+(j-1)*(K+1)+(0)])	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*****************************   Arete	Jp/Kp *****************************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYp==0)&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZp==0)&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXp==0)&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYp==0)&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZp==0)&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXp==0)&&(ConditionFaceYp==0))
    )
    {
#pragma omp parallel for private(Cjkjk) schedule(guided)
        for (i=1; i<W; i++)
        {

            Cjkjk=TableCjkjk[Carte_Tampon[(J-1)*(K)+(K-1)]];

            Tjk[(i)*(J+1)*(K+1)+(J)*(K+1)+(K)] += DeltaTsurH*Cjkjk*(
                    (	(Vj_BufferFaceAreteKp[i*(J+1)+J])
                        -	(Vj_I[(i)*(J+1)*(K)+(J)*(K)+(K-1)]		+	Vj_JK[(i)*(J+1)*(K)+(J)*(K)+(K-1)]	)	)	+
                    (	(Vk_BufferFaceAreteJp[i*(K+1)+K])
                        -	(Vk_I[(i)*(J)*(K+1)+(J-1)*(K+1)+(K)]	+	Vk_JK[(i)*(J)*(K+1)+(J-1)*(K+1)+(K)])	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*****************************   Arete	Jp/Km *****************************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYp==0)&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZp==0)&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXp==0)&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYp==0)&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZp==0)&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXp==0)&&(ConditionFaceYm==0))
    )
    {
#pragma omp parallel for private(Cjkjk) schedule(guided)
        for (i=1; i<W; i++)
        {

            Cjkjk=TableCjkjk[Carte_Tampon[(J-1)*(K)+(0)]];

            Tjk[(i)*(J+1)*(K+1)+(J)*(K+1)+(0)] += DeltaTsurH*Cjkjk*(
                    (	(Vj_I[(i)*(J+1)*(K)+(J)*(K)+(0)]			+	Vj_JK[(i)*(J+1)*(K)+(J)*(K)+(0)]		)
                        -	(Vj_BufferFaceAreteKm[i*(J+1)+J])	)	+
                    (	(Vk_BufferFaceAreteJp[i*(K+1)+0])
                        -	(Vk_I[(i)*(J)*(K+1)+(J-1)*(K+1)+(0)]	+	Vk_JK[(i)*(J)*(K+1)+(J-1)*(K+1)+(0)])	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*****************************   Arete	Jm/Kp *****************************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYm==0)&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZm==0)&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXm==0)&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYm==0)&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZm==0)&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXm==0)&&(ConditionFaceYp==0))
    )
    {
#pragma omp parallel for private(Cjkjk) schedule(guided)
        for (i=1; i<W; i++)
        {

            Cjkjk=TableCjkjk[Carte_Tampon[(0)*(K)+(K-1)]];

            Tjk[(i)*(J+1)*(K+1)+(0)*(K+1)+(K)] += DeltaTsurH*Cjkjk*(
                    (	(Vj_BufferFaceAreteKp[i*(J+1)+0])
                        -	(Vj_I[(i)*(J+1)*(K)+(0)*(K)+(K-1)]		+	Vj_JK[(i)*(J+1)*(K)+(0)*(K)+(K-1)]	)	)	+
                    (	(Vk_I[(i)*(J)*(K+1)+(0)*(K+1)+(K)]		+	Vk_JK[(i)*(J)*(K+1)+(0)*(K+1)+(K)]	)
                        -	(Vk_BufferFaceAreteJm[i*(K+1)+K])	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*****************************   Arete	Jm/Km *****************************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYm==0)&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZm==0)&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXm==0)&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYm==0)&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZm==0)&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXm==0)&&(ConditionFaceYm==0))
    )
    {
#pragma omp parallel for private(Cjkjk) schedule(guided)
        for (i=1; i<W; i++)
        {

            Cjkjk=TableCjkjk[Carte_Tampon[(0)*(K)+(0)]];

            Tjk[(i)*(J+1)*(K+1)+(0)*(K+1)+(0)] += DeltaTsurH*Cjkjk*(
                    (	(Vj_I[(i)*(J+1)*(K)+(0)*(K)+(0)]			+	Vj_JK[(i)*(J+1)*(K)+(0)*(K)+(0)]		)
                        -	(Vj_BufferFaceAreteKm[i*(J+1)+0])	)	+
                    (	(Vk_I[(i)*(J)*(K+1)+(0)*(K+1)+(0)]		+	Vk_JK[(i)*(J)*(K+1)+(0)*(K+1)+(0)]	)
                        -	(Vk_BufferFaceAreteJm[i*(K+1)+0])	)	);
        }
    }

    /*************************************************************************/
    /*********************** Calcul des coins de la face PML *****************/
    /*************************************************************************/

    /*****************************   Coin	Im/Jp/Kp ******************************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYp==0)&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZp==0)&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXp==0)&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYp==0)&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZp==0)&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXp==0)&&(ConditionFaceYp==0))
    )
    {

        Cjkjk=TableCjkjk[Carte_Tampon[(J-1)*(K)+(K-1)]];

        Tjk[(0)*(J+1)*(K+1)+(J)*(K+1)+(K)] += DeltaTsurH*Cjkjk*(
                (	(Vj_BufferFaceAreteKp[0*(J+1)+J])
                    -	(Vj_I[(0)*(J+1)*(K)+(J)*(K)+(K-1)]		+	Vj_JK[(0)*(J+1)*(K)+(J)*(K)+(K-1)]	)	)	+
                (	(Vk_BufferFaceAreteJp[0*(K+1)+K])
                    -	(Vk_I[(0)*(J)*(K+1)+(J-1)*(K+1)+(K)]	+	Vk_JK[(0)*(J)*(K+1)+(J-1)*(K+1)+(K)])	)	);
    }
    /*Cas de la symetrie est implicite*/
    /*****************************   Coin	Im/Jp/Km ******************************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYp==0)&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZp==0)&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXp==0)&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYp==0)&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZp==0)&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXp==0)&&(ConditionFaceYm==0))
    )
    {
        Cjkjk=TableCjkjk[Carte_Tampon[(J-1)*(K)+(0)]];

        Tjk[(0)*(J+1)*(K+1)+(J)*(K+1)+(0)] += DeltaTsurH*Cjkjk*(
                (	(Vj_I[(0)*(J+1)*(K)+(J)*(K)+(0)]			+	Vj_JK[(0)*(J+1)*(K)+(J)*(K)+(0)]		)
                    -	(Vj_BufferFaceAreteKm[0*(J+1)+J])	)	+
                (	(Vk_BufferFaceAreteJp[0*(K+1)+0])
                    -	(Vk_I[(0)*(J)*(K+1)+(J-1)*(K+1)+(0)]	+	Vk_JK[(0)*(J)*(K+1)+(J-1)*(K+1)+(0)])	)	);
    }
    /*Cas de la symetrie est implicite*/
    /*****************************   Coin	Im/Jm/Kp ******************************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYm==0)&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZm==0)&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXm==0)&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYm==0)&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZm==0)&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXm==0)&&(ConditionFaceYp==0))
    )
    {

        Cjkjk=TableCjkjk[Carte_Tampon[(0)*(K)+(K-1)]];

        Tjk[(0)*(J+1)*(K+1)+(0)*(K+1)+(K)] += DeltaTsurH*Cjkjk*(
                (	(Vj_BufferFaceAreteKp[0])
                    -	(Vj_I[(0)*(J+1)*(K)+(0)*(K)+(K-1)]		+	Vj_JK[(0)*(J+1)*(K)+(0)*(K)+(K-1)]	)	)	+
                (	(Vk_I[(0)*(J)*(K+1)+(0)*(K+1)+(K)]		+	Vk_JK[(0)*(J)*(K+1)+(0)*(K+1)+(K)]	)
                    -	(Vk_BufferFaceAreteJm[0*(K+1)+K])	)	);

    }
    /*Cas de la symetrie est implicite*/
    /*****************************   Coin	Im/Jm/Km ******************************/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYm==0)&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZm==0)&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXm==0)&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYm==0)&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZm==0)&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXm==0)&&(ConditionFaceYm==0))
    )
    {

        Cjkjk=TableCjkjk[Carte_Tampon[(0)*(K)+(0)]];

        Tjk[(0)*(J+1)*(K+1)+(0)*(K+1)+(0)] += DeltaTsurH*Cjkjk*(
                (	(Vj_I[(0)*(J+1)*(K)+(0)*(K)+(0)]			+	Vj_JK[(0)*(J+1)*(K)+(0)*(K)+(0)]		)
                    -	(Vj_BufferFaceAreteKm[0*(J+1)+0])	)	+
                (	(Vk_I[(0)*(J)*(K+1)+(0)*(K+1)+(0)]		+	Vk_JK[(0)*(J)*(K+1)+(0)*(K+1)+(0)]	)
                    -	(Vk_BufferFaceAreteJm[0])	)	);
    }
    /*Cas de la symetrie est implicite*/
}
