/* Copyright (C) 2003-2012 BOSSY Emmanuel.

This file is part of the SimSonic suite.

SimSonic is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SimSonic is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SimSonic.  If not, see <http://www.gnu.org/licenses/>. */

void CalculPMLFaceVitesses(PREC_GRILLE *Vi_I,PREC_GRILLE *Vi_JK,
                           PREC_GRILLE *Vj_I,PREC_GRILLE *Vj_JK,
                           PREC_GRILLE *Vk_I,PREC_GRILLE *Vk_JK,
                           PREC_GRILLE *Tii_I,PREC_GRILLE *Tii_JK,
                           PREC_GRILLE *Tjj_I,PREC_GRILLE *Tjj_JK,
                           PREC_GRILLE *Tkk_I,PREC_GRILLE *Tkk_JK,
                           PREC_GRILLE *Tij_I,PREC_GRILLE *Tij_JK,
                           PREC_GRILLE *Tki_I,PREC_GRILLE *Tki_JK,
                           PREC_GRILLE *Tjk,
                           int J, int K,
                           const char *TypeFace)
{

    int i,j,k;
    double Legerete;  /* Parametre effectif de lgeret*/
    double SignI;

    if (!strcmp(TypeFace,"Xp")||!strcmp(TypeFace,"Yp")||!strcmp(TypeFace,"Zp"))
        SignI = +1.0;
    else
        SignI = -1.0;

    /*   Bloc PML */

#pragma omp parallel for private(j,k,Legerete) schedule(guided)
    for (i=0; i<W; i++)
    {
        for (j=0; j<J; j++)
        {
            for (k=0; k<K; k++)
            {

                Legerete=TableLegerete[Carte_Tampon[(j)*(K)+(k)]];

                Vi_I[(i)*(J)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*(
                                                    (1-DeltaT*AttenuationPML[1+2*i])*Vi_I[(i)*(J)*(K)+(j)*(K)+(k)] + DeltaTsurH*Legerete*(
                                                        SignI*(	(Tii_I[(i+1)*(J)*(K)+(j)*(K)+(k)]		+			Tii_JK[(i+1)*(J)*(K)+(j)*(K)+(k)]		)
                                                                -	(Tii_I[(i)*(J)*(K)+(j)*(K)+(k)]			+			Tii_JK[(i)*(J)*(K)+(j)*(K)+(k)]			)	)	)	);

                Vi_JK[(i)*(J)*(K)+(j)*(K)+(k)] += DeltaTsurH*Legerete*																(
                                                      (	(Tij_I[(i)*(J+1)*(K)+(j+1)*(K)+(k)]		+		Tij_JK[(i)*(J+1)*(K)+(j+1)*(K)+(k)]		)
                                                              -	(Tij_I[(i)*(J+1)*(K)+(j)*(K)+(k)]			+		Tij_JK[(i)*(J+1)*(K)+(j)*(K)+(k)]			)	)	+
                                                      (	(Tki_I[(i)*(J)*(K+1)+(j)*(K+1)+(k+1)]	+		Tki_JK[(i)*(J)*(K+1)+(j)*(K+1)+(k+1)]	)
                                                              -	(Tki_I[(i)*(J)*(K+1)+(j)*(K+1)+(k)]		+		Tki_JK[(i)*(J)*(K+1)+(j)*(K+1)+(k)]		)	)	);

            }
        }
    }

#pragma omp parallel for private(j,k,Legerete) schedule(guided)
    for (i=1; i<W; i++)
    {
        for (j=1; j<J; j++)
        {
            for (k=0; k<K; k++)
            {

                Legerete=2./(1./TableLegerete[Carte_Tampon[(j-1)*(K)+(k)]]+1./TableLegerete[Carte_Tampon[(j)*(K)+(k)]]);

                Vj_I[(i)*(J+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                      (1-DeltaT*AttenuationPML[2*i])*Vj_I[(i)*(J+1)*(K)+(j)*(K)+(k)] + DeltaTsurH*Legerete*	(
                                                              SignI*(	(Tij_I[(i)*(J+1)*(K)+(j)*(K)+(k)]		+		Tij_JK[(i)*(J+1)*(K)+(j)*(K)+(k)]			)
                                                                      -	(Tij_I[(i-1)*(J+1)*(K)+(j)*(K)+(k)]	+		Tij_JK[(i-1)*(J+1)*(K)+(j)*(K)+(k)]		)		)	)	);

                Vj_JK[(i)*(J+1)*(K)+(j)*(K)+(k)] += DeltaTsurH*Legerete*													(
                                                        (	(Tjj_I[(i)*(J)*(K)+(j)*(K)+(k)]				+		Tjj_JK[(i)*(J)*(K)+(j)*(K)+(k)]		)
                                                                -	(Tjj_I[(i)*(J)*(K)+(j-1)*(K)+(k)]			+		Tjj_JK[(i)*(J)*(K)+(j-1)*(K)+(k)]	)	)	+
                                                        (	(Tjk[(i)*(J+1)*(K+1)+(j)*(K+1)+(k+1)]	+		0																	)
                                                                -	(Tjk[(i)*(J+1)*(K+1)+(j)*(K+1)+(k)]		+		0																	)	)	);
            }
        }
    }

#pragma omp parallel for private(j,k,Legerete) schedule(guided)
    for (i=1; i<W; i++)
    {
        for (j=0; j<J; j++)
        {
            for (k=1; k<K; k++)
            {

                Legerete=2./(1./TableLegerete[Carte_Tampon[(j)*(K)+(k-1)]]+1./TableLegerete[Carte_Tampon[(j)*(K)+(k)]]);

                Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*												(
                                                        (1-DeltaT*AttenuationPML[2*i])*Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(k)] + DeltaTsurH*Legerete*	(	(
                                                                SignI*(	(Tki_I[(i)*(J)*(K+1)+(j)*(K+1)+(k)]			+		Tki_JK[(i)*(J)*(K+1)+(j)*(K+1)+(k)]		)
                                                                        -	(Tki_I[(i-1)*(J)*(K+1)+(j)*(K+1)+(k)]		+		Tki_JK[(i-1)*(J)*(K+1)+(j)*(K+1)+(k)]	)			)	)	)	);

                Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(k)] += DeltaTsurH*Legerete*															(
                        (	(Tjk[(i)*(J+1)*(K+1)+(j+1)*(K+1)+(k)]		+		0																			)
                            -	(Tjk[(i)*(J+1)*(K+1)+(j)*(K+1)+(k)]			+		0																			)	)	+
                        (	(Tkk_I[(i)*(J)*(K)+(j)*(K)+(k)]					+		Tkk_JK[(i)*(J)*(K)+(j)*(K)+(k)]				)
                            -	(Tkk_I[(i)*(J)*(K)+(j)*(K)+(k-1)]				+		Tkk_JK[(i)*(J)*(K)+(j)*(K)+(k-1)]			)	)	);
            }
        }
    }

    /*  Face	bloc  	*/
#pragma omp parallel for private(k,Legerete) schedule(guided)
    for (j=1; j<J; j++)
    {
        for (k=0; k<K; k++)
        {

            Legerete=2./(1./TableLegerete[Carte_Tampon[(j-1)*(K)+(k)]]+1./TableLegerete[Carte_Tampon[(j)*(K)+(k)]]);

            Vj_I[(0)*(J+1)*(K)+(j)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                  (1-DeltaT*AttenuationPML[2*0])*Vj_I[(0)*(J+1)*(K)+(j)*(K)+(k)] + DeltaTsurH*Legerete*	(	(
                                                          SignI*(	(Tij_I[(0)*(J+1)*(K)+(j)*(K)+(k)]			+		Tij_JK[(0)*(J+1)*(K)+(j)*(K)+(k)]			)
                                                                  -	(Tij_BufferFaceBlocI[(j)*(K)+(k)]							+		0																			)	)	)	)	);

            Vj_JK[(0)*(J+1)*(K)+(j)*(K)+(k)] += DeltaTsurH*Legerete*(
                                                    (	(Tjj_I[(0)*(J)*(K)+(j)*(K)+(k)]				+	Tjj_JK[(0)*(J)*(K)+(j)*(K)+(k)]				)
                                                            -	(Tjj_I[(0)*(J)*(K)+(j-1)*(K)+(k)]			+	Tjj_JK[(0)*(J)*(K)+(j-1)*(K)+(k)]			)	)	+
                                                    (	(Tjk[(0)*(J+1)*(K+1)+(j)*(K+1)+(k+1)]	+	0																			)
                                                            -	(Tjk[(0)*(J+1)*(K+1)+(j)*(K+1)+(k)]		+	0																			)	)	);
        }
    }
#pragma omp parallel for private(k,Legerete) schedule(guided)
    for (j=0; j<J; j++)
    {
        for (k=1; k<K; k++)
        {

            Legerete=2./(1./TableLegerete[Carte_Tampon[(j)*(K)+(k-1)]]+1./TableLegerete[Carte_Tampon[(j)*(K)+(k)]]);

            Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                    (1-DeltaT*AttenuationPML[2*0])*Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(k)] + DeltaTsurH*Legerete*	(	(
                                                            SignI*(	(Tki_I[(0)*(J)*(K+1)+(j)*(K+1)+(k)]			+		Tki_JK[(0)*(J)*(K+1)+(j)*(K+1)+(k)]		)
                                                                    -	(Tki_BufferFaceBlocI[(j)*(K+1)+(k)]							+		0																			)	)	)	)	);

            Vk_JK[(0)*(J)*(K+1)+(j)*(K+1)+(k)] += DeltaTsurH*Legerete*															(
                    (	(Tjk[(0)*(J+1)*(K+1)+(j+1)*(K+1)+(k)]		+	0																			)
                        -	(Tjk[(0)*(J+1)*(K+1)+(j)*(K+1)+(k)]			+	0																			)	)	+
                    (	(Tkk_I[(0)*(J)*(K)+(j)*(K)+(k)]					+	Tkk_JK[(0)*(J)*(K)+(j)*(K)+(k)]				)
                        -	(Tkk_I[(0)*(J)*(K)+(j)*(K)+(k-1)]				+	Tkk_JK[(0)*(J)*(K)+(j)*(K)+(k-1)]			)	)	);
        }
    }
    /*  Face	arete Jp  	*/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXp==0))
    )
    {

#pragma omp parallel for private(k,Legerete) schedule(guided)
        for (i=1; i<W; i++)
        {
            for (k=0; k<K; k++)
            {

                Legerete=TableLegerete[Carte_Tampon[(J-1)*(K)+(k)]];

                Vj_I[(i)*(J+1)*(K)+(J)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                      (1-DeltaT*AttenuationPML[2*i])*Vj_I[(i)*(J+1)*(K)+(J)*(K)+(k)] + DeltaTsurH*Legerete*	(
                                                              SignI*(	(Tij_I[(i)*(J+1)*(K)+(J)*(K)+(k)]		+		Tij_JK[(i)*(J+1)*(K)+(J)*(K)+(k)]			)
                                                                      -	(Tij_I[(i-1)*(J+1)*(K)+(J)*(K)+(k)]	+		Tij_JK[(i-1)*(J+1)*(K)+(J)*(K)+(k)]		)		)	)	);

                Vj_JK[(i)*(J+1)*(K)+(J)*(K)+(k)] += DeltaTsurH*Legerete*													(
                                                        (	(Tjj_BufferFaceAreteJp[(i)*(K)+(k)]															)
                                                                -	(Tjj_I[(i)*(J)*(K)+(J-1)*(K)+(k)]			+		Tjj_JK[(i)*(J)*(K)+(J-1)*(K)+(k)]	)	)	+
                                                        (	(Tjk[(i)*(J+1)*(K+1)+(J)*(K+1)+(k+1)]	+		0																	)
                                                                -	(Tjk[(i)*(J+1)*(K+1)+(J)*(K+1)+(k)]		+		0																	)	)	);
            }
        }
    }
    /*Cas de la symetrie est implicite*/
    /*  Face	arete Jm 		*/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXm==0))
    )
    {
#pragma omp parallel for private(k,Legerete) schedule(guided)
        for (i=1; i<W; i++)
        {
            for (k=0; k<K; k++)
            {

                Legerete=TableLegerete[Carte_Tampon[(k)]];

                Vj_I[(i)*(J+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                                                      (1-DeltaT*AttenuationPML[2*i])*Vj_I[(i)*(J+1)*(K)+(0)*(K)+(k)] + DeltaTsurH*Legerete*	(
                                                              SignI*(	(Tij_I[(i)*(J+1)*(K)+(0)*(K)+(k)]		+		Tij_JK[(i)*(J+1)*(K)+(0)*(K)+(k)]			)
                                                                      -	(Tij_I[(i-1)*(J+1)*(K)+(0)*(K)+(k)]	+		Tij_JK[(i-1)*(J+1)*(K)+(0)*(K)+(k)]		)		)	)	);

                Vj_JK[(i)*(J+1)*(K)+(0)*(K)+(k)] += DeltaTsurH*Legerete*													(
                                                        (	(Tjj_I[(i)*(J)*(K)+(0)*(K)+(k)]				+		Tjj_JK[(i)*(J)*(K)+(0)*(K)+(k)]		)
                                                                -	(Tjj_BufferFaceAreteJm[(i)*(K)+(k)]																					)	)	+
                                                        (	(Tjk[(i)*(J+1)*(K+1)+(0)*(K+1)+(k+1)]	+		0																	)
                                                                -	(Tjk[(i)*(J+1)*(K+1)+(0)*(K+1)+(k)]		+		0																	)	)	);
            }
        }
    }

    /*Cas de la symetrie est implicite*/
    /* Face	arete Kp  	*/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceYp==0))
    )
    {
#pragma omp parallel for private(j,Legerete) schedule(guided)
        for (i=1; i<W; i++)
        {
            for (j=0; j<J; j++)
            {

                Legerete=TableLegerete[Carte_Tampon[(j)*(K)+(K-1)]];

                Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(K)] = 1./(1+DeltaT*AttenuationPML[2*i])*												(
                                                        (1-DeltaT*AttenuationPML[2*i])*Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(K)] + DeltaTsurH*Legerete*	(	(
                                                                SignI*(	(Tki_I[(i)*(J)*(K+1)+(j)*(K+1)+(K)]			+		Tki_JK[(i)*(J)*(K+1)+(j)*(K+1)+(K)]		)
                                                                        -	(Tki_I[(i-1)*(J)*(K+1)+(j)*(K+1)+(K)]		+		Tki_JK[(i-1)*(J)*(K+1)+(j)*(K+1)+(K)]	)			)	)	)	);

                Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(K)] += DeltaTsurH*Legerete*															(
                        (	(Tjk[(i)*(J+1)*(K+1)+(j+1)*(K+1)+(K)]		+		0																			)
                            -	(Tjk[(i)*(J+1)*(K+1)+(j)*(K+1)+(K)]			+		0																			)	)	+
                        (	(Tkk_BufferFaceAreteKp[i*(J)+j])
                            -	(Tkk_I[(i)*(J)*(K)+(j)*(K)+(K-1)]				+		Tkk_JK[(i)*(J)*(K)+(j)*(K)+(K-1)]			)	)	);
            }
        }
    }

    /*Cas de la symetrie est implicite*/
    /*  Face	arete Km 	*/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceYm==0))
    )
    {
#pragma omp parallel for private(j,Legerete) schedule(guided)
        for (i=1; i<W; i++)
        {
            for (j=0; j<J; j++)
            {

                Legerete=TableLegerete[Carte_Tampon[(j)*(K)+(0)]];

                Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*i])*												(
                                                        (1-DeltaT*AttenuationPML[2*i])*Vk_I[(i)*(J)*(K+1)+(j)*(K+1)+(0)] + DeltaTsurH*Legerete*	(	(
                                                                SignI*(	(Tki_I[(i)*(J)*(K+1)+(j)*(K+1)+(0)]			+		Tki_JK[(i)*(J)*(K+1)+(j)*(K+1)+(0)]		)
                                                                        -	(Tki_I[(i-1)*(J)*(K+1)+(j)*(K+1)+(0)]		+		Tki_JK[(i-1)*(J)*(K+1)+(j)*(K+1)+(0)]	)			)	)	)	);

                Vk_JK[(i)*(J)*(K+1)+(j)*(K+1)+(0)] += DeltaTsurH*Legerete*															(
                        (	(Tjk[(i)*(J+1)*(K+1)+(j+1)*(K+1)+(0)]		+		0																			)
                            -	(Tjk[(i)*(J+1)*(K+1)+(j)*(K+1)+(0)]			+		0																			)	)	+
                        (	(Tkk_I[(i)*(J)*(K)+(j)*(K)+(0)]					+		Tkk_JK[(i)*(J)*(K)+(j)*(K)+(0)]				)
                            -	(Tkk_BufferFaceAreteKm[i*(J)+j]																										)	)	);
            }
        }
    }
    /*Cas de la symetrie est implicite*/

    /*  Arete	Im/Jp		*/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXp==0))
    )
    {

#pragma omp parallel for private(Legerete) schedule(guided)
        for (k=0; k<K; k++)
        {

            Legerete=TableLegerete[Carte_Tampon[(J-1)*(K)+(k)]];

            Vj_I[(0)*(J+1)*(K)+(J)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                  (1-DeltaT*AttenuationPML[2*0])*Vj_I[(0)*(J+1)*(K)+(J)*(K)+(k)] + DeltaTsurH*Legerete*	(	(
                                                          SignI*(	(Tij_I[(0)*(J+1)*(K)+(J)*(K)+(k)]			+		Tij_JK[(0)*(J+1)*(K)+(J)*(K)+(k)]			)
                                                                  -	(Tij_BufferFaceBlocI[(J)*(K)+(k)]																								)	)	)	)	);

            Vj_JK[(0)*(J+1)*(K)+(J)*(K)+(k)] += DeltaTsurH*Legerete*													(
                                                    (	(Tjj_BufferFaceAreteJp[(0)*(K)+(k)]															)
                                                            -	(Tjj_I[(0)*(J)*(K)+(J-1)*(K)+(k)]			+		Tjj_JK[(0)*(J)*(K)+(J-1)*(K)+(k)]	)	)	+
                                                    (	(Tjk[(0)*(J+1)*(K+1)+(J)*(K+1)+(k+1)]																				)
                                                            -	(Tjk[(0)*(J+1)*(K+1)+(J)*(K+1)+(k)]																					)	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*   Arete	Im/Jm 		*/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceXm==0))
    )
    {

#pragma omp parallel for private(Legerete) schedule(guided)
        for (k=0; k<K; k++)
        {

            Legerete=TableLegerete[Carte_Tampon[(0)*(K)+(k)]];

            Vj_I[(0)*(J+1)*(K)+(0)*(K)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                  (1-DeltaT*AttenuationPML[2*0])*Vj_I[(0)*(J+1)*(K)+(0)*(K)+(k)] + DeltaTsurH*Legerete*	(
                                                          SignI*(	(Tij_I[(0)*(J+1)*(K)+(0)*(K)+(k)]		+		Tij_JK[(0)*(J+1)*(K)+(0)*(K)+(k)]			)
                                                                  -	(Tij_BufferFaceBlocI[(k)])																										)	)	);

            Vj_JK[(0)*(J+1)*(K)+(0)*(K)+(k)] += DeltaTsurH*Legerete*													(
                                                    (	(Tjj_I[(0)*(J)*(K)+(0)*(K)+(k)]				+		Tjj_JK[(0)*(J)*(K)+(0)*(K)+(k)]		)
                                                            -	(Tjj_BufferFaceAreteJm[(0)*(K)+(k)]																					)	)	+
                                                    (	(Tjk[(0)*(J+1)*(K+1)+(0)*(K+1)+(k+1)]																				)
                                                            -	(Tjk[(0)*(J+1)*(K+1)+(0)*(K+1)+(k)]																					)	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*  Arete	Im/Kp		*/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceYp==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceZp==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceXp==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceYp==0))
    )
    {

#pragma omp parallel for private(Legerete) schedule(guided)
        for (j=0; j<J; j++)
        {

            Legerete=TableLegerete[Carte_Tampon[(j)*(K)+(K-1)]];

            Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(K)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                                                    (1-DeltaT*AttenuationPML[2*0])*Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(K)] + DeltaTsurH*Legerete*	(	(
                                                            SignI*(	(Tki_I[(0)*(J)*(K+1)+(j)*(K+1)+(K)]			+		Tki_JK[(0)*(J)*(K+1)+(j)*(K+1)+(K)]		)
                                                                    -	(Tki_BufferFaceBlocI[(j)*(K+1)+(K)]							+		0																			)	)	)	)	);

            Vk_JK[(0)*(J)*(K+1)+(j)*(K+1)+(K)] += DeltaTsurH*Legerete*															(
                    (	(Tjk[(0)*(J+1)*(K+1)+(j+1)*(K+1)+(K)]		+	0																			)
                        -	(Tjk[(0)*(J+1)*(K+1)+(j)*(K+1)+(K)]			+	0																			)	)	+
                    (	(Tkk_BufferFaceAreteKp[j])
                        -	(Tkk_I[(0)*(J)*(K)+(j)*(K)+(K-1)]				+	Tkk_JK[(0)*(J)*(K)+(j)*(K)+(K-1)]			)	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
    /*   Arete	Im/Km		*/
    if(
        ((!strcmp(TypeFace,"Xp"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Yp"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zp"))&&(ConditionFaceYm==0))||
        ((!strcmp(TypeFace,"Xm"))&&(ConditionFaceZm==0))||
        ((!strcmp(TypeFace,"Ym"))&&(ConditionFaceXm==0))||
        ((!strcmp(TypeFace,"Zm"))&&(ConditionFaceYm==0))
    )
    {

#pragma omp parallel for private(Legerete) schedule(guided)
        for (j=0; j<J; j++)
        {

            Legerete=TableLegerete[Carte_Tampon[(j)*(K)+(0)]];

            Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*												(
                                                    (1-DeltaT*AttenuationPML[2*0])*Vk_I[(0)*(J)*(K+1)+(j)*(K+1)+(0)] + DeltaTsurH*Legerete*	(	(
                                                            SignI*(	(Tki_I[(0)*(J)*(K+1)+(j)*(K+1)+(0)]	+	Tki_JK[(0)*(J)*(K+1)+(j)*(K+1)+(0)]		)
                                                                    -	(Tki_BufferFaceBlocI[(j)*(K+1)+0]																						)		)	)	)	);

            Vk_JK[(0)*(J)*(K+1)+(j)*(K+1)+(0)] += DeltaTsurH*Legerete*															(
                    (	(Tjk[(0)*(J+1)*(K+1)+(j+1)*(K+1)+(0)]		+		0																			)
                        -	(Tjk[(0)*(J+1)*(K+1)+(j)*(K+1)+(0)]			+		0																			)	)	+
                    (	(Tkk_I[(0)*(J)*(K)+(j)*(K)+(0)]					+		Tkk_JK[(0)*(J)*(K)+(j)*(K)+(0)]				)
                        -	(Tkk_BufferFaceAreteKm[j]																													)	)	);
        }
    }
    /*Cas de la symetrie est implicite*/
}



